
(define make-selfsigned-cert (lambda (pkey)
  "Accept a private key and create a new self-signed X509 certificate"
  (define cert (X509_new))
  (let ()
    (define name (X509_NAME_new))
    (X509_NAME_add_entry_by_NID name NID_commonName MBSTRING_ASC "localhost" -1 -1 0)
    (let ()
      (define serial (ASN1_INTEGER_new))
      (ASN1_INTEGER_set serial (getpid))
      (X509_set_version cert 2)
      (X509_set_serialNumber cert serial)
      (X509_set_issuer_name cert name)
      (X509_set_subject_name cert name)
      (X509_gmtime_adj (X509_get_notBefore cert) 0)
      (X509_gmtime_adj (X509_get_notAfter cert) (* 60 60 24 90))
      (X509_set_pubkey cert pkey)
      (X509_sign cert pkey (EVP_sha1))
      cert
    )
  )
))
