(library (proverb doc)
(export with-docstring with-wiki-docstring)
(import (guile))

;
; Set this up now so that we can use the documentation primitives on the widest
; subset of Proverb possible.
;

(cond-expand
  (guile
    (define with-docstring (lambda (docstring body)
      (set-object-property! body 'documentation docstring)
      (set-object-property! docstring 'format 'text)
      body))
    (let ()
      (define d "accept a documentation string in plain text format <docstring> and a non-immediate Scheme value <body>. Associate the documentation with the scheme value.")
      (set-object-property! with-docstring 'documentation d)
      (set-object-property! d 'format 'text)
    )

    (define with-wiki-docstring (lambda (docstring body)
      (set-object-property! body 'documentation docstring)
      (set-object-property! docstring 'format 'wiki)
      body))
    (let ()
      (define d "accept a documentation string in wiki format <docstring> and a non-immediate Scheme value <body>. Associate the documentation with the scheme value.")
      (set-object-property! with-wiki-docstring 'documentation d)
      (set-object-property! d 'format 'text)
    )
  )
  (chicken
    ;not implemented
    (define-syntax with-docstring (syntax-rules ()
      ((with-docstring docstring body)
        body
      )
    ))
    ;not implemented
    (define-syntax with-wiki-docstring (syntax-rules ()
      ((with-docstring docstring body)
        body
      )
    ))
  )
  (else
    (define with-docstring (lambda (docstring body)
      body
    ))
    (define with-wiki-docstring (lambda (docstring body)
      body
    ))
  )
)

)
