;
; A number of subtle differences exist between guile 1.3 and guile 1.6 and guile 1.8
;

;;
;; guiles below 1.8.?? don't provide thunk?
;;
;(if (not (defined? 'thunk?))
;  (module-define! the-scm-module 'thunk (lambda (o)
;    "Is <o> a thunk?"
;    (if (procedure? o)
;      (let ()
;        (define arityval (procedure-property o 'arity))
;        (cond
;          ((equal? arityval '(0 0 #f)) #t)
;          ((equal? arityval '(0 0 #t)) #t)
;          (else #f)
;        )
;      )   
;      #f  
;    )
;  ))     
;)    

;
; I have heard reports that some Guiles don't support this
;
(if (not (defined? 'getproto))
  (module-define! the-scm-module 'getproto (lambda (name)
    (if (string=? name "IP")
      #("ip" ("IP") 0)
      #f
    )
  ))
)

;
; and that some guiles don't provide this
;
(if (not (defined? 'rmdir))
  (module-define! the-scm-module 'rmdir (lambda (dirname)
    (system (format #f "rmdir ~a" dirname))
  ))
)

;
; Guile has this broken as late as 1.8.3
; 
(set! environment-module (lambda (env)
  (let ((closure (and (pair? env) (car (last-pair env)))))
    (and closure (procedure? closure) (procedure-property closure 'module)))))

;
; This is experimental
;
(set! call-with-output-string (let ()
  (define old call-with-output-string)
  (lambda (func)
    (define sneaky-port #f)
    (define r (old (lambda (p)
      (set! sneaky-port p)
      (func p)
    )))
    (if sneaky-port (close sneaky-port))
    r
  )
))

;
; 
;
(if (not (defined? '%record-type-error))
  (module-define! the-scm-module '%record-type-error #f)
)


