(library (proverb patterns)
  (export
    bogo-string-match
    bogo-pattern-match
    make-character-dictionary
  )
  (import
    (rnrs)
    (rnrs lists)
    (proverb doc)
    (only (proverb dialect)
      list-head
      uniq
    )
    (only (guile)
      sort
    )
  )

  (define bogo-string-match (lambda (s l)
    (define sl (string-length s))
    (if (>= (length l) sl)
      (if (equal? (string->list s) (list-head l sl))
        (list-tail l sl)
        #f
      )
      #f
    )
  ))

  (define bogo-pattern-match (lambda (p l)
    (if (null? p)
      l
      (let ((t (car p)))
        (cond
          ((string? t) (let ((m (bogo-string-match t l)))
            (if m
              (bogo-pattern-match (cdr p) m)
              #f
            )
          ))
          ((eq? t 'EOF)
            (if (null? l)
              l
              #f
            )
          )
          (else #f)
        )
      )
    ) 
  ))

  (define make-character-dictionary (with-docstring
    "accept STRINGS and return a list of the set of characters in STRINGS"
    (lambda strings
      (map
        integer->char
        (uniq (sort
          (map char->integer 
               (apply append (map string->list strings))
          )
          <
        ))
      )
    )
  ))


)
