
(library (proverb persist)
  (export persist persist* persist-open)
  (import
    (ice-9 syncase)
    (rnrs)
    (rnrs arithmetic bitwise)
    (only (guile) open close O_CREAT O_APPEND O_WRONLY)
  )

  (define sleazy-persist-filename #f)

  (define persist-open (lambda (fname)
    (set! sleazy-persist-filename fname)
  ))

  (define persist* (lambda (form)
    (if sleazy-persist-filename
      (let ()
        (define f (open sleazy-persist-filename (bitwise-ior O_CREAT O_APPEND O_WRONLY)))
        (if f
          (begin
            (write form f)
            (newline f)
            (close f)
          )
        )
      )
    )
  ))

  (define-syntax persist (syntax-rules ()
    ((persist form) (begin (persist* (quote form)) form))
  ))
)
