(library (proverb regexp)
  (export regexp-escape-char regexp-escape-string)
  (import (proverb doc) (guile))

(define regexp-escape-char (with-docstring
  "accept a character <c> and return a string suitable for use as a literal character match in a POSIX regular expression"
  (lambda (char)
    (case char
      ((#\?) "[?]")
      (else (string char))
    )
  )
))
  
(define regexp-escape-string (with-docstring
  "produce a regexp string that would match the literal characters of <s>"
  (lambda (str)
    (apply string-append (map regexp-escape-char (string->list str)))
  )
))

)
