
(load "procedure-w-types.scm")

(define list-head (lambda (l counter)
  (let helper ((cursor l) (c counter) (racc '()))
    (if (equal? c 0)
      (reverse racc)
      (if (null? l)
        (error "out of bounds in list-head")
        (helper (cdr cursor) (- c 1) (cons (car cursor) racc))
      )
    )
  )
))

(define studio-pipe (lambda ()
  (display "STUDIO-PIPE SHOULD PROBABLY BE REPLACED ON SISC")
  (cons #f #f)
))
(define getpid (lambda ()
  (display "GETPID SHOULD PROBABLY BE REPLACED ON SISC")
  123
))
(define getsockname (lambda (s)
  (vector 0 0 0)
))
(define gethostname (lambda ()
  "localhost"
))
(define list-set! (lambda (l i v)
  (if (null? l)
    (error "index past end of list")
    (if (equal? i 0)
      (set-car! l v)
      (list-set! (cdr l) (- i 1) v)
    )
  )
))
(define hashq-set! (lambda (h k v)
  (hashtable/put! h k v)
))
(define hashq-ref (lambda (h k)
  (hashtable/get h k #f)
))
(define hashq-remove! (lambda (h k)
  (hashtable/remove! h k)
))
(define hashq (lambda (h s)
  (hash-by-eq h)
))
(define *unspecified* (void))
(define-syntax with-maybe-mutex (syntax-rules ()
  ((with-maybe-mutex mutex body ...) (begin body ...))
))
(define hash (lambda args
  (format #t "YOU TRIED TO HASH ~a\n" args)
  (hashq (car args) 1000)
))
(define delete-regexp (lambda args
  '()
))
(define current-load-dir (lambda ()
  (define u (normalize-url (current-url)))
  (if u
    (begin
      (if (member #\/ (string->list u))
        (get-parent-url u)
        "file:."
      )
    )
    #f
  )
))
(define dir->filelist (lambda (dirname)
  (directory-list dirname)
))
(define append-load-path! (lambda args #f))
(define procedure-source (lambda (p) #f))
(define current-module (lambda () (interaction-environment)))
(define make-mutex mutex/new)
(define string-hash  hash-by-string=)
(define hash-table? hashtable?)
(define studio-make-hash-table (lambda (hash-func eq-func . size)
  (make-hashtable equal? hash-by-equal)
))
(define studio-make-weak-value-hash-table (lambda args
  (apply studio-make-hash-table args)
))
(define object-property (lambda args #f))
(define object->string (lambda (o)
  (call-with-output-string (lambda (p) (write o p)))
))
(define make-fluid (lambda args
  (cons 'fluid #f)
))
;(define sort (lambda (l c)
;  (if (null? l)
;    '()
;    (if (null? (cdr l))
;      l
;      (if (null?  l))
;        (if (c (car l) (cadr l))
;          l
;          (list (cadr l) (car l))
;        )
;        (let ((sub (stable-sort (cdr l) c)))
;          (if (c (car l) (car sub))
;            (cons (car l) sub)
;            (cons (car sub) (stable-sort (cons (car l) (cdr sub)) c))
;          )
;        )
;      )
;    )
;  )
;))
;(define stable-sort sort)
(define R_OK 1)
(define access? (lambda (filename mode)
  (if (equal? mode R_OK)
    (file-is-readable? filename)
    #f
  )
))
(define string-split (lambda (s on)
  (let helper ((cursor (string->list s)) (macro-racc '()) (micro-racc '()))
    (if (null? cursor)
      (reverse (map list->string (cons (reverse micro-racc) macro-racc)))
      (if (eq? on (car cursor))
        (helper (cdr cursor) (cons (reverse micro-racc) macro-racc) '())
        (helper (cdr cursor) macro-racc (cons (car cursor) micro-racc))
      )
    )
  )
))
(define studio-string-split string-split)

(define set-object-property! (lambda (object property value)
  #t
))

(define delete (lambda (val l)
  (let helper ((cursor l) (racc '()))
    (if (null? cursor)
      (reverse racc)
      (if (equal? (car cursor) val)
        (helper (cdr cursor) racc)
        (helper (cdr cursor) (cons (car cursor) racc))
      )
    )
  )
))

(define make-guardian (lambda args
  (lambda args
    #f
  )
))

(define add-hook! (lambda args
  #f
))

(define after-gc-hook #f)

(define concurrent-apply-with-talkback (lambda args
  #f
))

(define make-hash-table (lambda args
  (make-hashtable eq? hash-by-eq #t)
))

(define hash-for-each (lambda args
  'fake-hash-for-each
))

(define hash-fold (lambda args
  'fake-hash-fold
))

(define once (lambda args
  'fake-once
))

(define sort (lambda args
  'fake-sort
))

; from the SISC manual
(import s2j)
(define-java-classes 
  <java.util.comparator> 
  <java.util.arrays> 
  <java.lang.object>) 
(define-java-proxy (comparator fn) 
  (<java.util.comparator>) 
  (define (.compare p obj1 obj2) 
    (let ([x (java-unwrap obj1)] 
          [y (java-unwrap obj2)]) 
      (->jint (cond [(fn x y) -1] 
                    [(fn y x) +1] 
                    [else 0]))))) 
(define list-sort (let ()
(define-generic-java-method sort) 
(define-java-class <java.lang.object>) 
(define (list-sort l fn) 
  (let ([a (->jarray (map java-wrap l) <java.lang.object>)]) 
  (display "FOO!\n")
  (sort (java-null <java.util.arrays>) a (comparator fn)) 
  (display "BAR!\n")
  (map java-unwrap (->list a)))) 
  list-sort
))
(define sort list-sort)


(define uniq (lambda (list)
  (let helper ((cursor list) (racc '()))
    (if (null? cursor)
      (reverse racc)
      (let ((n (cdr cursor)))
        (if (null? n)
          (helper n (cons (car cursor) racc))
          (helper n (if (eq? (car cursor) (cadr cursor))
            racc
            (cons (car cursor) racc)
          ))
        )
      )
    )
  )
))

(define-syntax use-modules (syntax-rules ()
  ((use-modules modnames ...) (begin
    (display "USING: ") (display (quote (modnames ...))) (newline)
  ))
))

(define receive-value read)

(define fdopen (lambda (fd mode)
  (if (string=? mode "r")
    (current-input-port)
    (current-output-port)
  )
))

