;
; Full of guileisms
;
(library (proverb test)
  (export
    define-test
    define-interactive-test
    define-macro-test
  )
  (import
    (rnrs)
    (proverb doc)
    (only (guile) set-object-property! cond-expand)
  )

(define define-test (with-docstring
  "accept a list of functions and a trailing body and associate the unit test with each of functions"
  (lambda args
    (define t (list-ref args (- (length args) 1)))
    (for-each (lambda (v)
      (set-object-property! v 'unit-test (list 'automatic t))
    ) (cdr (reverse args)))
  )
))

(define define-interactive-test (with-docstring
  "accept a list of functions and a trailing body and associate the unit test with each of functions. the body will be run and an observer must mark the pass"
  (lambda args
    (define t (list-ref args (- (length args) 1)))
    (for-each (lambda (v)
      (set-object-property! v 'unit-test (list 'interactive t))
    ) (cdr (reverse args)))
  )
))

(cond-expand
 (guile
   (define define-macro-test (with-docstring
  "accept the macro <name> and associate the unit test thunk <body> with it. The macro can be tested with (studio-test <name>)."
     (lambda (name body)
       (set-object-property! name 'unit-test (list 'automatic body))
     )
   ))
 )
 (chez
   (extend-syntax (define-macro-test)
    [(define-macro-test name body)
     (display "MACRO TEST YOU WISH!\n")]
   ) 
 )
 (else
   (define-syntax define-macro-test (syntax-rules ()
     ((define-macro-test name body) (display "MACRO TEST YOU WISH!\n"))
   ))
 )
)

)
