;
; This load phase allows each major Scheme variant to
; harmonize some bindings that we depend on but which
; vary from minor version to minor version. These
; files SHOULD NOT introduce entirely new Scheme
; functions.
(cond-expand
  (guile (load "guile-compatibility.scm"))
  (chicken (load "chicken-compatibility.scm"))
  ;(sisc
  ;  (define-syntax define-module (syntax-rules ()
  ;    ((define-module module-name) #t)
  ;  ))
  ;  (define set-object-property! (lambda args #t))
  ;  (define set-procedure-property! (lambda args #t))
  ;)
  (else #t)
)
(load "coredoc.scm")
(load "test.scm")
(load "procedure-w-types.scm")
(cond-expand
  (guile (load "guile-debug.scm"))
  (chicken (load "chicken-debug.scm"))
  (else
    #t ; no implementation-specific debugging
  )
)
(cond-expand
  (guile
    (load "studio-dialect.scm") 
  )
  (else
    #t ; already loaded
  )
)
(cond-expand
  (guile
    (load "cond-expand.scm")
  )
  (sisc
    #t ; ??
  )
)
(load "passval.scm")
(load "persist.scm")
;(load "lists.scm")
(cond-expand
  (guile
    (load "guile-util.scm")
  )
  (chicken
    (load "chicken-util.scm")
  )
  (else
    (display "SHOULD LOAD IMPLEMENTATION SPECIFIC UTILS ")
  )
)
(load "itree.scm")
(load "scheme-conv.scm")
(load "mime.scm")
(load "uri.scm")
(load "html.scm")
(load "xml.scm")
(load "regexp.scm")
(load "filesystem.scm")
(load "help.scm")
(load "wiki.scm")
(load "js.scm")
(load "queue.scm")
(load "getopt.scm")
(cond-expand
  (guile (load "consider.scm"))
  (else #t)
)
(load "consider.scm")
(load "search.scm")
(load "concurrent.scm")
(load "channels.scm")
(load "unread.scm")
(cond-expand
  (guile (load "threads.scm"))
  (else #t)
)
(load "branch.scm")
(load "hashtable.scm")
(load "tire.scm")
(load "remote.scm")
(load "ioforward.scm")
(load "md5.scm")
(load "patterns.scm")
(load "http.scm")
(load "http-cache.scm")
(load "http-upload.scm")
(load "http-rpc.scm")
(cond-expand
  (guile
    (load "interactive-completion.scm")
  )
  (else
    (display "SHOULD LOAD IMPLEMENTATION-SPECIFIC INTERACTIVE COMPLETION!\n")
  )
)
(load "xhtml.scm")
(load "diag.scm")
(load "jsshell.scm")
(load "vt100.scm")
(load "games.scm")
(cond-expand
  (guile
    (load "testcases.scm")
    (load "bench.scm")
  )
  (else
    #t
  )
)
