// Based on Pilaf's live preview code
// Stolen from: http://en.wikipedia.org/w/index.php?title=User:Pilaf/livepreview.js&action=raw&ctype=text/javascript&dontcountme=s

// updated by Dan Ridge to build DOM elements
// This code shouldn't build in any dependancies on our RPC
// scheme or on the rest of the shell variables. the generated
// XML can use our special tags.

// User options
var wpUserName=wpUserName||'Wikipedian';
var wpUserSignature=wpUserSignature||wpUserName;
var wpShowImages=wpShowImages||true;
var wpUserNamespace='usernamespacefoo';
var wpImageNamespace='imagenamespacefoo';
var wpCategoryNamespace='categorynamespacefoo';
var wpInterwikiCodes='Wikipedia|Wikifoo';
var wpBaseArticlePath='/basefoo';

function wiki2dom(str,ns,document_context,shell,xml2dom) {
  str=strip_cr(str);
  var w=new WikiCode(document_context,ns,shell,xml2dom);
  w.lines=str.split(/\n/);
  w.parse();
  return w.dom;
};

var wpSignature='[['+wpUserNamespace+':'+wpUserName+'|'+wpUserSignature+']]';var wpBlockImage=new RegExp('^\\[\\['+wpImageNamespace+':.*?\\|.*?(?:frame|thumbnail|thumb|none|right|left|center)','i');

function wiki_attrib_escape(str) {
    return str.replace(/'/g,"&apos;")
              .replace(/"/g,"&quot;")
              .replace(/</g,"&lt;")
};

function WikiCode(document_context,ns,shell,xml2dom) {
  this.lines=new Array;
  this.document=document_context;
  this.dom=this.document.createElement('div');
  this.xml2dom=xml2dom;

  this._endline=function() {
    var x=arguments;
    var xi=0;
    while(xi < x.length) {
      this.dom.appendChild(x[xi]);
      xi++;
    }
    this.lines.shift();
  };

  this.parse=function() {
    var p=false;
    do{
      var h_match;

      // something is dodgy about this code on some browsers

      h_match=this.lines[0].match(/^(={1,6})(.*)\1(.*)$/);
      if(h_match) {
        p=false;
        var helem;
        helem=this.document.createElement('h'+h_match[1].length);
        _parse_inline_nowiki(h_match[2],ns,helem,shell,this.xml2dom);
        if(h_match[3] != '') {
	  var pelem;
          alert('jsshell mediawiki parser: undomly header in this.parse: \"' + h_match[3] + '\"');
	  pelem=this.document.createElement('p');
          pelem.innerHTML=h_match[3];
          this._endline(helem,pelem);
        } else {
          this._endline(helem);
        }
      } else if(this.lines[0].match(/^[*#:;]/)) {
        p=false;
        this._parse_list();
      } else if(this.lines[0].charAt(0)==' ') {
        p=false;
        this._parse_pre();
      } else if(this.lines[0].match(/^&&/)) {
        p=false;
        this._parse_pre_strict(/^&&/,'wiki_pre');
      } else if(this.lines[0].match(/^%%/)) {
        p=false;
        this._parse_pre_strict(/^%%/,'wiki_literal');
      } else if(this.lines[0].match(/^\$\$/)) {
        p=false;
        this._parse_code();
      } else if(this.lines[0].substr(0,2)=='{|') {
        p=false;
        this._parse_table();
      } else if(this.lines[0].match(/^----+$/)) {
        p=false;
        this._endline(this.document.createElement('hr'));
      } else if(this.lines[0].match(wpBlockImage)) {
        p=false;this._parse_block_image();
      } else {
        if(this.lines[0]=='') {
          if(p=(this.lines.length>1&&this.lines[1]=='')) {
            this._endline(this.document.createElement('p'));
          } else {
            p=true;
            this.dom.appendChild(this.document.createElement('br'));
          }
        } else {
          if(!p) {
            this.dom.appendChild(this.document.createElement('p'));
            p=true;
          }
          _parse_inline_nowiki(this.lines[0],ns,this.dom,shell,this.xml2dom);
        }
        this.lines.shift();
      }
    } while(this.lines.length);
  };


  this._parse_list=function() {
    var prev=new String;
    var l_match,imatch,dt_match;
    //var lval=false;    
    var lval=Array();
    lval.unshift(this.dom);

    while(this.lines.length&&(l_match=this.lines[0].match(/^([*#:;]+)(.*)$/))) {
      this.lines.shift();
      imatch=str_imatch(prev,l_match[1]);
      for(var i=prev.length-1;i>=imatch;i--) {
        if(prev.charAt(i)=='*') {
          lval.shift();
        } else if(prev.charAt(i)=='#') {
          lval.shift();
        } else {
          this.html+='</d'+((prev.charAt(i)==';')?'t':'d')+'>';
          switch(l_match[1].charAt(i)) {
          case'':
          case'*':
          case'#':
            lval.shift();
            this.html+='</dl>';
          }
        }
      }
      for(var i=imatch;i<l_match[1].length;i++) {
        if(l_match[1].charAt(i)=='*') {
          var l=this.document.createElement('ul');
          lval[0].appendChild(l);
          lval.unshift(l);
        } else if(l_match[1].charAt(i)=='#') {
          var l=this.document.createElement('ol');
          lval[0].appendChild(l);
          lval.unshift(l);
        } else {
          switch(prev.charAt(i)) {
          case'':
          case'*':
          case'#':
            var l=this.document.createElement('ol');
            lval[0].appendChild(l);
            lval.unshift(l);
          }
	  alert('bogo1');
          this.html+='<d'+((l_match[1].charAt(i)==';')?'t':'d')+'>';
        }
      }
      switch(l_match[1].charAt(l_match[1].length-1)) {
      case'*':
      case'#':
        var lival;
        lival=this.document.createElement('li');
        _parse_inline_nowiki(l_match[2],ns,lival,shell,this.xml2dom);
        lval[0].appendChild(lival);
        break;
      case';':
        if(dt_match=l_match[2].match(/(.*?) (:.*?)$/)) {
          _parse_inline_nowiki(dt_match[1],ns,this.dom,shell,this.xml2dom);
          this.lines.unshift(dt_match[2]);
          break;
        }
      case':':
        _parse_inline_nowiki(l_match[2],ns,this.dom,shell,this.xml2dom);
      }
      prev=l_match[1];
    }

    for(i=prev.length-1;i>=0;i--) {
      if(prev.charAt(i)=='*') {
        lval.shift();
      } else if(prev.charAt(i)=='#') {
        lval.shift();
      } else {
        lval.shift();
        //this.html+='</d'+((prev.charAt(i)==';')?'t':'d')+'></dl>';
      }
    }
  };

  this._parse_table=function() {
    var table_match;
    var our_html='';
    var e=this._endline;
    var bogo_endline=function(str) {
      our_html+=str;
      e();
    };
    var tval;
    var rowval;

    if(table_match=this.lines[0].match(/^\{\|( .*)$/)) {
      alert('extra attributes: ' + table_match[1]);
      tval=this.document.createElement('table');
      this.lines.shift();
    } else {
      tval=this.document.createElement('table');
      this.lines.shift();
    }
    
    tval.setAttribute('border','1');
    this.dom.appendChild(tval);
  
    do {
      //alert('lead: ' + this.lines[0].charAt(0) + ' -- line: ' + this.lines[0]);
      if(this.lines[0].charAt(0)=='|') {
        switch(this.lines[0].charAt(1)) {
        case '}':
          //alert('finished table: ' + our_html);
          this.lines.shift();
          return;
        case '+': {
          rowval=this.document.createElement('tr');
          tval.appendChild(rowval);
          var capval=this.document.createElement('caption');
          capval.appendChild(this.document.createTextNode(this.lines[0].substr(2)));
          tval.appendChild(capval);
          this.lines.shift();
          //this._parse_table_data('|',tval,rowval);
          break;
        }
        case '-':
          rowval=this.document.createElement('tr');
          //alert('tr attribs: ' + this.lines[0].match(/\|-*(.*)/)[1]);
	  tval.appendChild(rowval);
          this.lines.shift();
          break;
        default:
          this._parse_table_data(tval,rowval);
        }
      } else if(this.lines[0].charAt(0)=='!') {
        this._parse_table_data(tval,rowval);
      } else {
        alert('else???');
        this.lines.shift();
      }
    } while(this.lines.length)
  };

  this._parse_table_data=function(t,elem) {
    var td_match,td_line;
    var sep;

    // any row can begin with a bang
    // Here are some possible syntaxes that don't appear to be addressed in
    // mediawiki pipe syntax:
    // ! foo || bar || baz
    // ! foo !! bar || baz

    var exp = /^(!|\|)((?:([^[|]*?)\|(?!\|))?(.*))$/;
    var l;

    //td_match=this.lines.shift().match(/^(\|\+|\||!)((?:([^[|]*?)\|(?!\|))?(.*))$/);
    l=this.lines.shift();
    td_match=l.match(exp);

    var celltype;
    var sep;

    sep=td_match[1];
    if(td_match[1] == '|') {
      celltype='td';
    } else if(td_match[1] == '!') {
      celltype='th';  
    }

    if(typeof td_match[3]!='undefined') {
      // we are using single pipe syntax to set cell attributes
      this.html+=' '+td_match[3];td_line=td_match[4].split(sep+sep);
    } else {
      td_line=td_match[2].split(sep+sep);
    }

    while(td_line.length>1) {
      //alert('unshifting some lines!');
      this.lines.unshift(td_match[1]+td_line.pop());
    }

    // parse the body of a single cell  
    {
      var cellval=this.document.createElement(celltype);
      elem.appendChild(cellval);
      _parse_inline_nowiki(td_line[0],ns,cellval,shell,this.xml2dom);
    }

    var table_count=0;

    while(this.lines.length) {
      if(this.lines[0].charAt(0)=='|') {
        if(table_count==0)
          break;
        else if(this.lines[0].charAt(1)=='}')
          table_count--;
      } else if(this.lines[0].charAt(0)=='!') {
        if(table_count==0)
          break;
      } else if(this.lines[0].charAt(0)==sep&&table_count==0) {
        break;
      } else if(this.lines[0].substr(0,2)=='{|') {
        table_count++;
      }

      var td=new WikiCode(this.document,ns,shell,this.xml2dom);
      //alert('pushing a line into the sub table -- ' + this.lines[0]);
      td.lines.push(this.lines.shift());
    
      if(td.lines.length) {
        td.parse();
      }
      {
        var cellval=this.document.createElement('td');
        elem.appendChild(cellval);
        cellval.appendChild(td.dom);
      }
    }
  };

  this._parse_pre=function() {
    var preval=this.document.createElement('pre');

    do{
      _parse_inline_nowiki(this.lines[0].substring(1,this.lines[0].length),ns,preval,shell,this.xml2dom);
      preval.appendChild(this.document.createTextNode('\n'));
      this.lines.shift();
    } while(this.lines.length&&this.lines[0].charAt(0)==' ');

    this.dom.appendChild(preval);
  };

  this._parse_pre_strict=function(ongoing_exp,css_class) {
    var dval=this.document.createElement('div');     
    var shell_span=document.createElement('span');
    var s;
    dval.className=css_class;
    do {
      s=document.createElement('span');
      s.className='line';
      s.appendChild(document.createTextNode(tty_string_escape(this.lines[0].substr(2))));
      dval.appendChild(s);
      dval.appendChild(document.createElement('br'));
      this.dom.appendChild(dval);
      this.lines.shift();
    } while(this.lines.length&&this.lines[0].match(ongoing_exp));
  };

  this._parse_code=function() {
    var a;
    var silent_eval=false;
    var dval=this.document.createElement('div');     
    var literal_text='';
    var shell_span=document.createElement('span');
    var sval=this.document.createElement('span');
    var s;
    dval.className='wiki_code';
    if(this.lines[0] == "$$!") {
      this.lines.shift();
      silent_eval=true;
    }
    this.dom.appendChild(this.document.createElement('br'));
    this.dom.appendChild(sval);
    this.dom.appendChild(this.document.createElement('br'));
    do {
      literal_text+=this.lines[0].substr(2)+'\n';
      s=document.createElement('span');
      s.className='line';
      s.appendChild(document.createTextNode(tty_string_escape(this.lines[0].substr(2))));
      dval.appendChild(s);
      dval.appendChild(document.createElement('br'));
      this.dom.appendChild(dval);
      this.lines.shift();
    } while(this.lines.length&&this.lines[0].match(/^\$\$/));
    if(silent_eval) {
      _string_to_dom(
        "<shell visible='true'>" + wiki_attrib_escape(literal_text) + "'</shell>",
        sval,
        xml2dom);
    } else {
      _string_to_dom(
        "<shell visible='true' wait='true'>" + wiki_attrib_escape(literal_text) + "'</shell>",
        sval,
        xml2dom);
    }
  };

  this._parse_block_image=function() {
    this.html+=_parse_image(this.lines.shift(),this,shell,xml2dom);
  };
};
_string_to_dom=function(str,obj,xml2dom) {
  var t;
  var tp=new DOMParser();
  var doc=tp.parseFromString('<xhtml>'+str+'</xhtml>',"text/xml");
  
  var roottag = doc.documentElement;
  if ((roottag.tagName == "parserError") ||
      (roottag.namespaceURI == "http://www.mozilla.org/newlayout/xml/parsererror.xml")) {
    alert("Error parsing mediawiki string: " + str);
    return false;
  }

  var x = doc.getElementsByTagName('xhtml'); 
  if(x) {
    xml2dom(x[0],function(v) { obj.appendChild(v); });
  }
  return obj;
};


_parse_inline_nowiki=function(str,ns,elem,shell,xml2dom) {
  var start,lastend=0
  var substart=0,nestlev=0,open,close,subloop;
  var html='';

  while(-1!=(start=str.indexOf('<'+'nowiki>',substart))) {
    alert('inside inline_nowiki');
    html+=_parse_inline_wiki(str.substring(lastend,start),shell,xml2dom);
    start+=8;
    substart=start;
    subloop=true;
    do {
      open=str.indexOf('<'+'nowiki>',substart);
      close=str.indexOf('</nowiki>',substart);
      if(close<=open||open==-1) {
        if(close==-1) { return _string_to_dom(html+html_entities(str.substr(start)),elem,xml2dom);}
        substart=close+9;
        if(nestlev) {
          nestlev--;
        } else {
          lastend=substart;
          html+=html_entities(str.substring(start,lastend-9));
          subloop=false;
        }
      } else {
        substart=open+8;nestlev++;
      }
    } while(subloop);
  }

  {
    //var d=this.document.createElement('span');
    var d=document.createElement('span');
    if(html!='') {
      var pre=this.document.createElement('span');
      alert('undomly html in parse_inline_nowiki');
      pre.innerHTML=html;
      d.appendChild(pre);
    }
    _parse_inline_wiki_to_dom(str.substr(lastend),ns,d,shell,xml2dom);
    elem.appendChild(d);
  }
};

function _parse_image_to_dom(str,shell,xml2dom) {
  var attr=str.substring(wpImageNamespace.length+3,str.length-2).split(/\s*\|\s*/);
  var filename=attr[0];
  var caption=attr[attr.length-1];
  var width,w_match;
  var thumb=false;
  var frame=false;
  var center=false;
  var align='';
  var html='';
  var div=this.document.createElement('div');

  do {
    if(w_match=attr[0].match(/^(\d*)px$/)) {
      width=w_match[1];
    } else switch(attr[0]) {
      case'thumb':
      case'thumbnail':
        thumb=true;
      case'frame':
        frame=true;
        break;
      case'none':
      case'right':
      case'left':
        center=false;
        align=attr[0];
        break;
      case'center':
        center=true;
        align='none';
    }

    attr.shift();
  } while(attr.length);

  if(frame) {
    var d;
    if(align=='') align='right';
    d=this.document.createElement('div');
    d.className='thumb t'+align;
    div.appendChild(d);
    if(thumb) {
      var e,f,g,h,i,j,k;
      if(!width) width=wpDefaultThumbWidth;
      e=this.document.createElement('div');
      div.style.width=(2+parseInt(width))+"px";
      d.appendChild(e);
      e.appendChild(_make_image_to_dom(filename,caption,width));
      f=this.document.createElement('div');
      f.className='thumbcaption';
      e.appendChild(f);
      g=this.document.createElement('div');
      g.className='thumbcaption';
      f.appendChild(g);
      h=this.document.createElement(h);
      h.className='magnify';
      h.style.float='right';
      g.appendChild(h);
      i=this.document.createElement('a');
      i.href=wpBaseArticlePath+wpImageNamespace+':'+filename;
      i.className='internal';
      i.title='Enlarge';
      h.appendChild(i);
      j=this.document.createElement('img');
      j.src=wpSkinMagnifyClip;
      i.appendChild(j);
      k=this.document.createTextNode(_parse_inline_nowiki(caption,ns,bogo,shell,xml2dom));
      g.appendChild(k);
    } else {
      var e,f,g;
      e=this.document.createElement('div');
      d.appendChild(e);
      e.appendChild(_make_image_to_dom(filename,caption));
      f=this.document.createElement('div');
      f.className='thumbcaption';
      e.appendChild(f);
      g=this.document.createTextNode(_parse_inline_nowiki(caption,ns,bogo,shell,xml2dom));
      f.appendChild(g)
    }
  } else if(align!='') {
    var d,e,f;
    d=this.document.createElement('div');
    d.className='float' + align;
    div.appendChild(d);
    e=this.document.createElement('span');
    d.appendChild(e);
    e.appendChild(make_image_to_dom(filename,caption,width));
  } else {
    return _make_image_to_dom(filename,caption,width);
  }

  if(center) {
    var d;
    d=this.document.createElement('div');
    d.className=center;
    d.appendChild(div);
    div=d;
  }
  return div;
}


 function _parse_image(str,shell,xml2dom) {
  var attr=str.substring(wpImageNamespace.length+3,str.length-2).split(/\s*\|\s*/);
  var filename=attr[0];
  var caption=attr[attr.length-1];
  var width,w_match;
  var thumb=false;
  var frame=false;
  var center=false;
  var align='';
  var html='';
  do {
    if(w_match=attr[0].match(/^(\d*)px$/)) {
      width=w_match[1];
    } else switch(attr[0]) {
      case'thumb':
      case'thumbnail':
        thumb=true;
      case'frame':
        frame=true;
        break;
      case'none':
      case'right':
      case'left':
        center=false;
        align=attr[0];
        break;
      case'center':
        center=true;
        align='none';
    }

    attr.shift();
  } while(attr.length);

  if(frame) {
    if(align=='') align='right';
    html+="<div class='thumb t"+align+"'>";
    if(thumb) {
      if(!width) width=wpDefaultThumbWidth;
      html+="<div style='width:"+(2+parseInt(width))+"px;'>";
      html+=_make_image(filename,caption,width);
      html+="<div class='thumbcaption'><div class='magnify' style='float:right'><a href='"+wpBaseArticlePath+wpImageNamespace+':'+filename+"' class='internal' title='Enlarge'><img src='"+wpSkinMagnifyClip+"' /></a></div>"+_parse_inline_nowiki(caption,ns,bogo,shell,xml2dom)+"</div>";
    } else {
      html+='<div>';
      html+=_make_image(filename,caption);
      html+="<div class='thumbcaption'>"+_parse_inline_nowiki(caption,ns,bogo,shell,xml2dom)+"</div>";
    }
    html+='</div></div>';
  } else if(align!='') {
    html+="<div class='float"+align+"'><span>"+_make_image(filename,caption,width)+"</span></div>";
  } else {
    return _make_image(filename,caption,width);
  }
  if(center) {
    return"<div class='center'>"+html+'</div>';
  } else {
    return html;
  }
};

function _make_image(filename,caption,width) {
  filename=filename.charAt(0).toUpperCase()+filename.substr(1);
  filename=filename.replace(/ /g,'_');
  var md5=crypt.md5(filename);
  var source=md5.charAt(0)+'/'+md5.substr(0,2)+'/'+filename;
  var img;
  if(wpShowImages) {
    if(width) {
      width="width='"+width+"px'";
    }
    img="<img onerror='this.onerror=null;this.src=\""+wpImageFallbackPath+source+"\";' src='"+wpImageBasePath+source+"' alt='"+caption+"' "+width+"/>";
  } else {
   img=wpImageNamespace+':'+filename+" <em style='color:red;'>(images disabled)</em>";
  }
  caption=_strip_inline_wiki(caption);
  return"<a class='image' title='"+caption+"' href='"+wpBaseArticlePath+wpImageNamespace+':'+filename+"'>"+img+"</a>";
};

function _make_image_to_dom(filename,caption,width) {
  filename=filename.charAt(0).toUpperCase()+filename.substr(1);
  filename=filename.replace(/ /g,'_');
  var md5=crypt.md5(filename);
  var source=md5.charAt(0)+'/'+md5.substr(0,2)+'/'+filename;
  var img;
  var anchor;
  if(wpShowImages) {
    img=this.document.createElement('img');
    img.onerror=function() {
      this.onerror=null;
      this.src=wpImageFallbackPath+source;
    }
    img.src=wpImageBasePath+source;
    img.alt=caption;
    if(width) {
      img.width=width+"px";
    }
  } else {
   img=this.document.createElement('span');
   img.appendChild(this.document.createTextNode(wpImageNamespace+':'+filename+' (images disabled)'));
  }
  caption=_strip_inline_wiki(caption);
  anchor=this.document.createElement('a');
  anchor.className='image';
  anchor.title=caption;
  anchor.href=wpBaseArticlePath+wpImageNameSpace+':'+filename;
  anchor.appendChild(img);
  return anchor;
};

function _parse_inline_images(str,shell,xml2dom) {
  var start,substart=0,nestlev=0;
  var loop,close,open,wiki,html;

  while(-1!=(start=str.indexOf('[[',substart))) {
    if(str.substr(start+2).match(RegExp('^'+wpImageNamespace+':','i'))) {
      loop=true;
      substart=start;
      do{
        substart+=2;
        close=str.indexOf(']]',substart);
        open=str.indexOf('[[',substart);
        if(close<=open||open==-1) {
          if(close==-1)  return str;
          substart=close;
          if(nestlev) {
            nestlev--;
          } else {
            wiki=str.substring(start,close+2);
            html=_parse_image(wiki,shell,xml2dom);
            str=str.replace(wiki,html);
            substart=start+html.length;
            loop=false;
          }
        } else { 
          substart=open;nestlev++;
        }
      } while(loop);
    } else {
      break;
    }
  }
  return str;
};

function _parse_inline_wiki_to_dom(str,ns,elem,shell,xml2dom) {
  //var v;

  function pattern_helper(expr,inner) {
    var match;
    if(match=expr.exec(str)) {
      if(match.index != 0) {
        _parse_inline_wiki_to_dom(str.substr(0,match.index),ns,elem,shell,xml2dom);
      } 
      inner(match);
      if( (match.index + match[0].length) < str.length) {
        _parse_inline_wiki_to_dom(str.substr(match.index+match[0].length),ns,elem,shell,xml2dom);
      }
      return true;
    } else { 
      return false;
    }
  }

  /* I think these patterns don't need a 'g' modifier as we process
     process matches one at a time anyway and don't provide for
     overlapping matches. 'g' appeared to produce incorrect and
     difficult to diagnose matches anyway. I think there may be
     a case where re.lastIndex remains stuck and applied to new
     strings inappropriately. --DSKR
  */
  if (
    pattern_helper(/'''''(.*?)''(.*?)'''/,function(match) {
      var d=this.document.createElement('strong');
      var e=this.document.createElement('em');
      _parse_inline_wiki_to_dom(match[1],ns,e,shell,xml2dom);
      d.appendChild(e);
      _parse_inline_wiki_to_dom(match[2],ns,d,shell,xml2dom);
      elem.appendChild(d);
    }) || pattern_helper(/'''''(.*?)'''(.*?)''/,function(match) {
      var d=this.document.createElement('em');
      var e=this.document.createElement('strong');
      _parse_inline_wiki_to_dom(match[1],ns,e,shell,xml2dom);
      d.appendChild(e);
      _parse_inline_wiki_to_dom(match[2],ns,d,shell,xml2dom);
      elem.appendChild(d);
    }) || pattern_helper(/'''(.*?)''(.*?)'''''/,function(match) {
      var d=this.document.createElement('strong');
      var e=this.document.createElement('em');
      _parse_inline_wiki_to_dom(match[1],ns,d,shell,xml2dom);
      d.appendChild(e);
      _parse_inline_wiki_to_dom(match[2],ns,e,shell,xml2dom);
      elem.appendChild(d);
    }) || pattern_helper(/'''(.*?)'''/,function(match) {
      var d=this.document.createElement('strong');
      _parse_inline_wiki_to_dom(match[1],ns,d,shell,xml2dom);
      elem.appendChild(d);
    }) || pattern_helper(/''(.*?)''/,function(match) {
      var d=this.document.createElement('em');
      _parse_inline_wiki_to_dom(match[1],ns,d,shell,xml2dom);
      elem.appendChild(d);
    // a proverb specific extension
    }) || pattern_helper(/```(.*?)```/,function(match) {
      /* Yipes! We went to all of this trouble to rewrite the
       * wiki code as DOMwise and here we are with a nasty
       * wodge of XML! That's because these are Replete
       * extensions that we can't manufacture with
       * createElement. The right thing is probably to
       * parameterize the wiki parser with some type
       * of dispatch for non-DOM elements.
       */
      _string_to_dom(
        "<domshell>" + match[1] + "</domshell>",
        elem,
        xml2dom);
    }) || pattern_helper(/``(.*?)``/,function(match) {
      _string_to_dom(
        "<shell>" + match[1] + "</shell>",
        elem,
        xml2dom);
    }) || pattern_helper(/~{5}(?!~)/,function(match) {
      var d=this.document.createTextNode(Date());
      elem.appendChild(d);
    }) || pattern_helper(/~{4}(?!~)/,function(match) {
      var d=this.document.createTextNode('SIGNATURE: ' + Date());
      elem.appendChild(d);
    }) || pattern_helper(/~{3}(?!~)/,function(match) {
      var d=this.document.createTextNode('SIGNATURE');
      elem.appendChild(d);
    }) || pattern_helper(/\[\[\[\[([^|]*?)\]\]\]\](\w*)/,function (match) {
      var s=this.document.createElement('span');
      _string_to_dom(
        "<shortcut-anchor form='" + wiki_attrib_escape(match[1]) + "'>" + match[1] + match[2] + "</shortcut-anchor>",
        s,
        xml2dom);
      s.appendChild(document.createTextNode(' yields '));
      _string_to_dom("<domshell>" + match[1] + "</domshell>", s, xml2dom);
      elem.appendChild(s);
    }) || pattern_helper(/\[\[\[\[(.*?)\|([^\]]+?)\]\]\]\](\w*)/,function (match) {
      var s=this.document.createElement('span');
      _string_to_dom(
        "<shortcut-anchor form='" + wiki_attrib_escape(match[1]) + "'>" + match[1] + match[3] + "</shortcut-anchor>",
        s,
        xml2dom);
      s.appendChild(document.createTextNode(' ' + match[2] + ' '));
      _string_to_dom("<domshell>" + match[1] + "</domshell>",
        s,
        xml2dom);
      elem.appendChild(s);
    }) || pattern_helper(/\[\[\[\[([^\]]*?:)?(.*?)( *\(.*?\))?\|\]\]\]\]/,function (match) {
      var s=this.document.createElement('span');
      _string_to_dom(
        "<shortcut-anchor form='" + wiki_attrib_escape(match[1]+match[2]+match[3]) + "'></shortcut-anchor>",
        s,
        xml2dom);
      s.appendChild(document.createTextNode(' yields '));
      _string_to_dom(
        "<domshell>" + match[1]+match[2]+match[3] + "</domshell>",
        s,
        xml2dom);
      elem.appendChild(s);
    }) || pattern_helper(/\[\[\[([^|]*?)\]\]\](\w*)/,function (match) {
      _string_to_dom(
        "<shortcut-anchor form='" + wiki_attrib_escape(match[1]) + "'>" + match[1] + match[2] + "</shortcut-anchor>",
        elem,
        xml2dom);
    }) || pattern_helper(/\[\[\[(.*?)\|([^\]]+?)\]\]\](\w*)/,function (match) {
      _string_to_dom(
        "<shortcut-anchor form='" + wiki_attrib_escape(match[1]) + "'>" + match[2] + match[3] + "</shortcut-anchor>",
        elem,
        xml2dom);
    }) || pattern_helper(/\[\[\[([^\]]*?:)?(.*?)( *\(.*?\))?\|\]\]\]/,function (match) {
      _string_to_dom(
        "<shortcut-anchor form='" + wiki_attrib_escape(match[1]+match[2]+match[3]) + "'>" + match[2] + "</shortcut-anchor>",
        elem,
        xml2dom);
    }) || pattern_helper(/\[\[([^|]*?)\]\](\w*)/,function (match) {
      _string_to_dom(
        "<wiki-anchor " + (ns?("base='" + wiki_attrib_escape(ns) + "' "):"") + "article='" + wiki_attrib_escape(match[1]) + "'>" + match[1] + match[2] + "</wiki-anchor>",
        elem,
        xml2dom);
    }) || pattern_helper(/\[\[(.*?)\|([^\]]+?)\]\](\w*)/,function (match) {
      _string_to_dom(
        "<wiki-anchor " + (ns?("base='" + wiki_attrib_escape(ns) + "' "):"") + "article='" + wiki_attrib_escape(match[1]) + "'>" + match[2] + match[3] + "</wiki-anchor>",
        elem,
        xml2dom);
    }) || pattern_helper(/\[\[([^\]]*?:)?(.*?)( *\(.*?\))?\|\]\]/,function (match) {
      _string_to_dom(
        "<wiki-anchor " + (ns?("base='" + wiki_attrib_escape(ns) + "' "):"") + "article='" + wiki_attrib_escape(match[1]+match[2]+match[3]) + "'>" + match[2] + "</wiki-anchor>",
        elem,
        xml2dom);
    }) || pattern_helper(/\[(http|https|news|ftp|mailto|gopher|irc|file|xmpp):(\/*)([^\]]*?) (.*?)\]/,function (match) {
      _string_to_dom(
        "<sanchor href='" + wiki_attrib_escape(match[1]+':'+match[2]+match[3]) + "'>" + match[4] + "</sanchor>",
        elem,
        xml2dom);
    }) || pattern_helper(/\[(local):(\/*)([^\]]*?) (.*?)\]/,function (match) {
      _string_to_dom(
        "<sanchor href='" + wiki_attrib_escape(match[2]+match[3]) + "'>" + match[4] + "</sanchor>",
        elem,
        xml2dom);
    }) || pattern_helper(/\[(http|https):\/\/(.*?)\]/,function (match) {
      _string_to_dom(
        "<sanchor href='" + match[1]+ "://" + wiki_attrib_escape(match[2]) + "'>[#]</sanchor>",
        elem,
        xml2dom);
    }) || pattern_helper(/\[local:(\/*.*?)\]/,function (match) {
      _string_to_dom(
        "<sanchor href='" + wiki_attrib_escape(match[1]) + "'>[#]</sanchor>",
        elem,
        xml2dom);
    }) || pattern_helper(/\[(news|ftp|mailto|gopher|irc|xmpp):(\/*)(.*?)\]/,function (match) {
      _string_to_dom(
        "<sanchor href='" + wiki_attrib_escape(match[1] + ':' + match[2] + match[3]) + "'>" + match[1]+':'+match[2]+match[3]+"</sanchor>",
        elem,
        xml2dom);
    }) || pattern_helper(/(^| )(http|https|news|ftp|mailto|gopher|irc|xmpp):(\/*)([^ $]*)/,function(match) {
      _string_to_dom(
        match[1]+"<sanchor href='" + wiki_attrib_escape(match[2] + ':' + match[3] + match[4]) + "'>" + match[2] + ":" + match[3] + match[4] + "</sanchor>",
        elem,
        xml2dom);
    }) || pattern_helper(/{{([^}:]*?):([^}]*?)}}/,function(match) {
      var w=jspref_wikis[match[1]];
      if(w) {
        w=w.get_article;
      }
      if(w) {
        w(match[2],shell,function(t) {
          if(t) {
            var e=wiki2dom(t,ns,document,shell,xml2dom);
            elem.appendChild(e);
          } else {
            elem.appendChild(document.createTextNode('could not transclude article ' + match[2]));
          }
        });
      } else {
        elem.appendChild(document.createTextNode('cannot transclude from namespace ' + match[1]));
      }
    }) || pattern_helper(/{{([^}]*?)}}/,function(match) {
      var w=jspref_wikis[ns];
      if(w) {
        w=w.get_article;
      }
      if(w) {
        w(match[1],shell,function(t) {
          if(t) {
            var e=wiki2dom(t,ns,document,shell,xml2dom);
            elem.appendChild(e);
          } else {
            elem.appendChild(document.createTextNode('could not transclude article ' + match[1]));
          }
        });
      } else {
        elem.appendChild(document.createTextNode('cannot transclude from namespace ' + ns));
      }
    }) || pattern_helper(/__NOTOC__/,function(match) {
      // these are blank replacements
    }) || pattern_helper(/__NOEDITSECTION__/,function(match) {
      // these are blank replacements
    })
  ) {
    1;
  } else {
    /* There is some fiddliness about whitespace here */
    //elem.appendChild(this.document.createTextNode(' '+str+' '));
    elem.appendChild(document.createTextNode(' '+str+' '));
  }

  return true;
}

function _strip_inline_wiki(str) {
  return str.replace(/\[\[[^\]]*\|(.*?)\]\]/g,'$1').replace(/\[\[(.*?)\]\]/g,'$1').replace(/''(.*?)''/g,'$1');
};

function max(a,b) {
  if(a>b)
    return a;
  else
    return b;
};

function min(a,b) {
  if(a<b)
    return a;
  else
    return b;
};

function str_imatch(str_a,str_b) {
var lim=min(str_a.length,str_b.length);for(var i=0;i<lim;i++){if(str_a.charAt(i)!=str_b.charAt(i))return i;}
return i;
};

function strip_cr(str) {
  return str.replace(/\n\r/g,"\n").replace(/\r/g,'');
};

function html_entities(str) {
  //return str.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;");
  return str.replace(/&/g,"&amp;amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;");
};
