// Routines for converting an XML tree to DOM objects
// This file provides a global array 'dumpers' that
// can be extended to provide support for new, application
// specific XML tags.

//
// This whole thing is a disgusting hack. We should probably
// style the XML with XSLT in the browser instead.
//

var dumpers;
var string_dumpers;
var js_dumpers;

(function() {

// just a wrapper around xhtml tags
function dump_xhtml(v,document_context,namespace,shell,continuation) {
  dump_child_nodes(v,document_context,namespace,shell,continuation);
}

function node_text(v) {
  var i='';
  var t='';
  var node;
  for(i=0;i<v.childNodes.length;i++) {
    node=v.childNodes[i];
    if(node.nodeType == 3 ) {
      t+=node.data;
    }
  }
  return t;
}

function dump_widgetscript(v,document_context,namespace,shell,continuation) {
  var script_body='';
  var hidden;
  var key;

  script_body=node_text(v);

  if(v.attributes.getNamedItem('hidden')) {
    hidden=true;
  } else {
    hidden=false;
  }

  if(v.attributes.getNamedItem('key')) {
    key=v.attributes.getNamedItem('key').value;
  } else {
    key=false;
  }

  var bogo_interior;

  var bogo_widget=libreplete.make_widget(document_context,shell,script_body,key,hidden);

  var s=document_context.createElement('script');
  var this_widget_function;
  //firefox 3 introduces a weird syntax requirement that
  //functions be named or assigned. You can't eval a form
  //that returns an anonymous lambda. Veeery dissatisfying to me.
  eval('this_widget_function=function (widget) { ' + script_body + ' };');
  var finishup = function() {
    if(typeof(this_widget_function) == 'function') {
      bogo_interior = new this_widget_function(bogo_widget);  
    } else {
      alert('widget body was wrong type of object');
    }
  };

  if(hidden) {
    finishup();
    continuation(s);
  } else {
    var widget_wrapper=libreplete.make_dom_widget(document_context,shell);
    bogo_widget.div=widget_wrapper;
    widget_wrapper.finalize=function() {
      if(bogo_widget.finalize) {
        bogo_widget.finalize();
      }
    };
    bogo_widget.close=function() {
      widget_wrapper.close();
    };

    widget_wrapper.onload=function() {
      alert('script load');
    }
    widget_wrapper.appendChild(s);
    finishup();
    if(v.attributes.getNamedItem('fullscreen')) {
      with_fullscreen_div(function(d) {
        d.appendChild(widget_wrapper);   
      });
    } else {
      continuation(widget_wrapper);
    }
  }
}

function dump_ref(v,document_context,namespace,shell,continuation) {
  alert('dumping a ref');
  continuation(document_context.createTextNode('REF'));
}

function dump_ref_to_js(node,shell) {
  var val=false;

  if(node.attributes.getNamedItem('key')) {
    val=node.attributes.getNamedItem('key').value;
    alert('ref key is: ' + val);
/*
    bogo_widget.wrapper=function (s) {
      return '(xhtml-widget-eval (quote ' + s + ') ' + val + ')';
    };
    bogo_widget.formals='](xhtml-widget-formals ' + val + ')';
    bogo_widget.finalize=function() {
        shell.inner_evaluator.evaluator('](xhtml-widget-delete! ' + val + ')',document_context,shell,function(v) { return false; });
    }
*/
  }

  return function(cont) {
    if(val) {
    	alert('calling a ref: ' + arguments.length);
    	shell.inner_evaluator.eval_to_js('](xhtml-widget-formals ' + val + ')',shell,cont);
    } else {
      alert('ref with no key');
    }
  };
};

function bogo_dump_ref(v,document_context,namespace,shell,continuation) {
  alert('dumping a ref');
  /*var script_body='';
  script_body=node_text(v);

  var bogo_interior;
  var bogo_widget=new Object();

  bogo_widget.shell=shell;
  */
  if(v.attributes.getNamedItem('key')) {
    var val=v.attributes.getNamedItem('key').value;
    alert('with a key: ' + val);
/*
    bogo_widget.wrapper=function (s) {
      return '(xhtml-widget-eval (quote ' + s + ') ' + val + ')';
    };
    bogo_widget.formals='](xhtml-widget-formals ' + val + ')';
    bogo_widget.finalize=function() {
        shell.inner_evaluator.evaluator('](xhtml-widget-delete! ' + val + ')',document_context,shell,function(v) { return false; });
    }
*/
  }

  continuation(false);
/*
  var s=document_context.createElement('script');
  var this_widget_function;
  //firefox 3 introduces a weird syntax requirement that
  //functions be named or assigned. You can't eval a form
  //that returns an anonymous lambda. Veeery dissatisfying to me.
  eval('this_widget_function=function (widget) { ' + script_body + ' };');
  var finishup = function() {
    if(typeof(this_widget_function) == 'function') {
      bogo_interior = new this_widget_function(bogo_widget);  
    } else {
      alert('widget body was wrong type of object');
    }
  };

  if(v.attributes.getNamedItem('hidden')) {
    finishup();
    continuation(s);
  } else {
    var widget_wrapper=libreplete.make_dom_widget(document_context,shell);
    bogo_widget.div=widget_wrapper;
    widget_wrapper.finalize=function() {
      if(bogo_widget.finalize) {
        bogo_widget.finalize();
      }
    };
    bogo_widget.close=function() {
      widget_wrapper.close();
    };

    widget_wrapper.onload=function() {
      alert('script load');
    }
    widget_wrapper.appendChild(s);
    finishup();
    continuation(widget_wrapper);
  }
*/
}

function dump_widget(v,document_context,namespace,shell,continuation) {
  var w=libreplete.make_dom_widget(document_context,shell);
  var subc=function(e) {
    w.appendChild(e);
  };

  if(shell.widget_window) {
    alert('widget_window: ' + shell.widget_window);
  }

  dump_child_nodes(v,document_context,namespace,shell,subc);

  continuation(w);
}

function dump_shell(v,document_context,namespace,shell,continuation) {
  var t=node_text(v);
  var n=document_context.createElement('span');
  if(v.attributes.getNamedItem('visible')) {
    var b=make_evaluating_anchor(document_context,namespace,shell,t,'iwta_eval_anchor',true,false);
    b.appendChild(document.createTextNode('evaluate'));
    n.appendChild(b);
  }
  continuation(n);
  if(v.attributes.getNamedItem('wait')) {
  } else {
    shell.inner_evaluator.eval_to_string(t,shell,function(v) {
      n.appendChild(document_context.createTextNode(v));
    });
  }
}

function dump_domshell(v,document_context,namespace,shell,continuation) {
  var t=node_text(v);
  var n=document.createElement('span');
  var subshell=shell.subshell(function(res) {
    n.appendChild(res);
  });
  subshell.string_evaluator(t,false);
  continuation(n); 
}

function dump_redir(v,document_context,namespace,shell,continuation) {
  var t;
  t=v.attributes.getNamedItem('target');
  if(t && t.value) {
    var n=document_context.getElementById(t.value);
    if(n) {
      dump_child_nodes(v,document_context,namespace,shell,function(v) {
        n.appendChild(v); 
      });
    } else {
      alert('target doesnt exist');
      dump_child_nodes(v,document_context,namespace,shell,continuation);
    }
  } else {
    alert('no target attribute');
    dump_child_nodes(v,document_context,namespace,shell,continuation);
  }
}

function dump_replace(v,document_context,namespace,shell,continuation) {
  var t;
  t=v.attributes.getNamedItem('target');
  if(t && t.value) {
    var n=document_context.getElementById(t.value);
    if(n) {
      var i,node
      while(n.childNodes.length>0) {
        n.removeChild(n.childNodes[0]);
      }
      dump_child_nodes(v,document_context,namespace,shell,function(v) {
        n.appendChild(v); 
      });
    } else {
      alert('target doesnt exist');
      dump_child_nodes(v,document_context,namespace,shell,continuation);
    }
  } else {
    alert('no target attribute');
    dump_child_nodes(v,document_context,namespace,shell,continuation);
  }
}

function dump_sanchor(v,document_context,namespace,shell,continuation) {
  continuation(make_url_anchor(v,document_context,namespace,shell,v.attributes.getNamedItem('href').value));
}

function make_evaluating_anchor(document_context,namespace,shell,form,classname,echo,spinoff) {
  var newnode=document_context.createElement('a');
  newnode.jsshell_command=form;
  newnode.addEventListener("click",function(e) {
    if(shell.jsprefs.getpref('anchors_eval')) {
      if(spinoff) {
        var new_window=window.open('/jsshell/sub.xhtml','','');
        new_window.onload=function() {
          var subshell=shell.subshell(function(v) {
            new_window.document.body.appendChild(v);
          });
          subshell.string_evaluator(e.target.jsshell_command,echo);
        }
      } else {
        shell.string_evaluator(e.target.jsshell_command,echo);
      }
    } else {
      alert('evaluation not enabled');
    }
  },false);
  newnode.className=classname;

  return newnode;
}
function make_evaluating_anchor_tag(v,document_context,namespace,shell,form,classname,echo) {
  var spinoff=v.attributes && v.attributes.getNamedItem('new') && v.attributes.getNamedItem('new').value;
  var newnode=make_evaluating_anchor(document_context,namespace,shell,form,classname,echo,spinoff);

  dump_child_nodes(v,document_context,namespace,shell,function(e) {
    newnode.appendChild(e);
  });

  return newnode;
}

//
// wiki anchors are emitted only by the in-browser MediaWiki parser. They
// exist only because the path to a pure-DOM MediaWiki solution is
// slow. I will remove them just as soon as possible.
// 
function dump_wiki_anchor(v,document_context,namespace,shell,continuation) {
  var base=v.attributes.getNamedItem('base');
  var article=v.attributes.getNamedItem('article').value;
  var wiki;
  if(article.match(/:/)) {
    wiki=article.replace(/:.*/,"");
    // trim whitespace
    wiki=wiki.replace(/^[ ]*/,"");
    article=article.replace(/[^:]*:/,"");
    // trim trailing whitespace
    article=article.replace(/[ ]*$/,"");
  } else {
    if(base && base.value) {
      wiki=base.value;
    } else {
      wiki=shell.jsprefs.getpref('default_wiki');
    }
  }
  if(jspref_wikis[wiki]) {
    continuation(jspref_wikis[wiki].make_anchor(v,document_context,namespace,shell,article));
  } else {
    continuation(document.createTextNode("UNKNOWN_WIKI_NAMESPACE -- '" + wiki + "'"));
  }
}

function dump_evaluating_anchor(v,document_context,namespace,shell,continuation,echo) {
  var form=v.attributes.getNamedItem('form').value;
  var newnode=make_evaluating_anchor_tag(v,document_context,namespace,shell,form,'iwta_eval_anchor',echo);
  continuation(newnode);
}

// an eval anchor evaluates the 'form' of the anchor without echoing the form
function dump_eval_anchor(v,document_context,namespace,shell,continuation) {
  dump_evaluating_anchor(v,document_context,namespace,shell,continuation,false);
}

function dump_shortcut_anchor(v,document_context,namespace,shell,continuation) {
  dump_evaluating_anchor(v,document_context,namespace,shell,continuation,shell.jspref_shortcuts_echo);
}

function dump_script_obj(v,document_context,namespace,shell,continuation) {
  alert('dumping script object');
  continuation(eval(v.innerHTML));
}

function dump_html_fragment(v,document_context,namespace,shell,continuation) {
  var div=document_context.createElement('div');
  div.innerHTML=v.attributes.getNamedItem('text').value;
  continuation(div);
}

function dump_text_to_string(v) {
  return v.attributes.getNamedItem('text').value;
}

//var dump_text = make_text_dumper(dump_text_to_string);
var dump_text = function(v,document_context,namespace,shell,continuation) {
  return dump_string_without_quoting(v,document_context,namespace,shell,continuation,false); 
};

function dump_wiki(v,document_context,namespace,shell,continuation) {
  var base=v.attributes.getNamedItem('base');

  if(base && base.value) {
    base=base.value;
  } else {
    base=shell.jsprefs.getpref('default_wiki');
  }
  var script_body=node_text(v);
  var span=document_context.createElement('span');
  span.className='wiki';
  span.appendChild(
    wiki2dom(script_body,base,document_context,shell,function(o,c) {
      dump_node(o,document_context,namespace,shell,c);
    })
  );
  continuation(span);
}

dumpers = new Object();
string_dumpers = new Object();
js_dumpers = new Object();

// Don't add a new tag here without updating the documentation
// in portable/doc.scm

// generic dumpers
dumpers['wiki'] = dump_wiki;
dumpers['xhtml'] = dump_xhtml;
dumpers['sanchor'] = dump_sanchor;
dumpers['eval-anchor'] = dump_eval_anchor;
dumpers['shortcut-anchor'] = dump_shortcut_anchor;
// you should not use wiki-anchors
dumpers['wiki-anchor'] = dump_wiki_anchor;
dumpers['html-fragment'] = dump_html_fragment;
// maybe phase text out?
dumpers['text'] = dump_text;
dumpers['widget'] = dump_widget;
dumpers['widgetscript'] = dump_widgetscript;
//dumpers['mime'] = dump_mime;
dumpers['shell'] = dump_shell;
dumpers['domshell'] = dump_domshell;
dumpers['redir'] = dump_redir;
dumpers['replace'] = dump_replace;
dumpers['ref'] = dump_ref;

js_dumpers['ref']=dump_ref_to_js;

})();

/* not used by an atom -- used by port I/O code */
function dump_string_without_quoting(v,document_context,namespace,shell,continuation,escaper) {
  var span=document_context.createElement('span');
  var i,node;
  //span.onclick=clicky;
  var charset=v.attributes.getNamedItem('charset');

  var rewriter;

  if(escaper) {
    rewriter=function(s) {
      return document_context.createTextNode(tty_string_escape(escaper(s)));
    };
  } else {
    rewriter=function(s) {
      return document_context.createTextNode(tty_string_escape(s));
    };
  }

  if(charset) {
    span.charset=charset.value;
  }

  if(v.firstChild) {

    for(i=0;i<v.childNodes.length;i++) {
      node=v.childNodes[i];
      if(node.nodeType != 3) {
        if(node.nodeName == 'char') {
          var code=node.attributes.getNamedItem('code');
          if(code) {
            var codenum=parseInt(code.value);
            if(codenum==9) {
              span.appendChild(rewriter('        '));
            } else {
              var b=codenum.toString(8);
              var j;
              for(j=b.length;j<3;j++) {
                b="0"+b;
              }
              span.appendChild(document.createTextNode('\\' + b));
            }
          } 
        } else {
          alert('found node in soup. ' + node.nodeName);
        }
        continue;
      }
      var s_array=node.nodeValue.split("\n");
      var j;
      for(j=0;j<s_array.length;j++) {
        var n=rewriter(s_array[j]);
        if(charset) n.charset=charset.value;
        span.appendChild(n);
        break;
      }
      for(j=1;j<s_array.length;j++) {
        span.appendChild(document_context.createElement('br'));
        var n=rewriter(s_array[j]);
        if(charset) n.charset=charset.value;
        span.appendChild(n);
      }
    }
  } else {
      span.appendChild(document_context.createTextNode(""));
  }

  continuation(span);
}


function tty_string_escape(s) {
  return s.replace(/ /g,"\u00a0").replace(/\t/g,"\u00a0");
}

// dump all the children of node v. V has presumably been handled itself
// by the caller. Most callers will supply their own continuation.
function dump_child_nodes(v,document_context,namespace,shell,continuation) {
  dump_node_array(v.childNodes,document_context,namespace,shell,continuation);
}

function dump_unknown(v,document_context,namespace,shell,continuation) {
  var newnode;
  var ns;
  var item,child,i;
  
  if(!v.attributes) {
    alert('dumping unknown node -- node has no attributes! tagname: ' + v.tagName + ' node: ' + v);
  } else if(v.attributes.getNamedItem('xmlns')) {
    ns=v.attributes.getNamedItem('xmlns').value;
  } else {
    ns=namespace;
  }

  if(ns == 'proverb') {
    ns=false;
  }

  // is this right?
  if(ns) {
    newnode = document_context.createElementNS(ns,v.nodeName);
  } else {
    newnode = document_context.createElement(v.nodeName);
  }
  
  // populate the attributes
  for(i = 0; i < v.attributes.length; i++ ) {
    item=v.attributes.item(i);
    //eval('newnode.'+item.name+'="'+item.value+'";');
    if(ns) {
      // we already accounted for the namespace
      if(item.name != 'xmlns') { 
        newnode.setAttributeNS(null,item.name,item.value);
      }
    } else {
      newnode.setAttribute(item.name,item.value);
    }
  };

  // populate the children
  dump_child_nodes(v,document_context,ns,shell,function(e) {
    newnode.appendChild(e);
  });

  continuation(newnode,document_context);
}

function dump_node(node,document_context,namespace,shell,continuation) {
  var name = node.nodeName;
  var dumper=dumpers[name];
  var ns=false;
  // we defer to the namespace if one exists and is not us
  if(dumper && namespace && namespace != "proverb") {
    // check for a switch back to the proverb namespace
    if(!node.attributes) {
      alert('dumping unknown node -- node has no attributes! tagname: ' + v.tagName + ' node: ' + node);
    } else if(node.attributes.getNamedItem('xmlns')) {
      ns=node.attributes.getNamedItem('xmlns').value;
    }
    if(ns != 'proverb') {
      dumper = dump_unknown;
    } else {
      namespace=ns;
    }
  } else {
    if( ! dumper || (namespace && namespace != "proverb") ) { dumper = dump_unknown; }
  }
  dumper(node,document_context,namespace,shell,continuation);
}

function dump_node_to_string(node) {
  var name = node.nodeName;
  var dumper = string_dumpers[name];

  if( ! dumper ) { return "UNKNOWN TAG NAME: " + node; }
  return dumper(node);
}

function dump_node_to_js(node,shell) {
  var name = node.nodeName;
  var dumper = js_dumpers[name];
  
  if(dumper) {
    return dumper(node,shell);
  } else {
    var s=document.createElement('span');
    dump_node(node,document,"proverb",shell,function(e) { s.appendChild(e); });
    return s;
  }
}

// Eat out just the response
function dump_node_array(node_array,document_context,namespace,shell,continuation) {
  var i,node;

  for(i=0;i<node_array.length;i++) {
    node=node_array[i];
    if(node.nodeType == 1) {
      dump_node(node,document_context,namespace,shell,continuation);
    } else if(node.nodeType == 3) {
      continuation(document_context.createTextNode(node.data));
    }
    break;
  }
  for(i=i+1;i<node_array.length;i++) {
    node=node_array[i];
    if(node.nodeType == 1) {
      continuation(document_context.createTextNode(" "));
      dump_node(node,document_context,namespace,shell,continuation);
    } else if(node.nodeType == 3) {
      continuation(document_context.createTextNode(node.data));
    }
  }
}

function make_text_class_dumper(stringizer,cssclass) {
  return function(v,document_context,namespace,shell,continuation) {
    var span=document_context.createElement('span');
    var exp=document_context.createTextNode(stringizer(v));
    span.className=cssclass;
    span.appendChild(exp);
    //span.onclick=clicky;
    continuation(span);
  };
}

function make_text_dumper(stringizer) {
  return function(v,document_context,namespace,shell,continuation) {
    var span=document_context.createElement('span');
    var exp=document_context.createTextNode(stringizer(v));
    span.appendChild(exp);
    //span.onclick=clicky;
    continuation(span);
  };
}

function make_url_anchor(v,document_context,namespace,shell,url) {

  var anchor=document_context.createElement('a');
  anchor.jsshell_command=':' + url;
  anchor.addEventListener('click',function (e) {
    if(portable.meta_key_p(e)) {
      if(portable.shift_key_p(e)) {
        shell.string_evaluator('::' + url,true);
      } else {
        shell.string_evaluator(anchor.jsshell_command,true);
      } 
    } else {
      //var new_window = window.open(url,'','');
      shell.string_evaluator(anchor.jsshell_command,true);
    } 
  },false);
  anchor.className='iwta_external_anchor';

  dump_child_nodes(v,document_context,namespace,shell,function(e) {
    anchor.appendChild(e);
  });

  return anchor;
}
