// RPC functions for the JavaScript Shell
// this file should be kept small and focused on
// cross browser portability.

// should you ever want to use the response as a DOM element, use
// continuation(req.responseXML.documentElement);

// inspired by apple. failure_continuation is passed the javascript error object
function rpc(url,command,success_continuation,failure_continuation) {
  var req = false;

  function process_req_change(e) {
    if(req.responseText && req.responseText[0] != '<') {
      alert('some non-xml text: ' + req.responseText + ' and e.status is: ' + req.status);
    } else {
      if(success_continuation) {
        success_continuation(req); 
      }
    }
  }

  // branch for native XMLHttpRequest object
  if(window.XMLHttpRequest) {
    try {
      req = new XMLHttpRequest();
    } catch(e) {
      req = false;
    }
  }

  if(req) {
    req.open("POST", url, true);
    req.withCredentials = "true";
    //req.overrideMimeType('text/xml');
    req.onreadystatechange = process_req_change;
    req.onerror = function(r) {
      if(failure_continuation) { 
        failure_continuation(r);
      }
    };
    req.send(command);
  }
}

// callback gets handed the XML sexp elements error_callback gets the javascript error
var global_rpc_counter=0;
//var rpc_history=new Array();

var bogo_response=false;

function xmlrpc(url,form,callback,error_callback) {
  var this_rpc_count=global_rpc_counter;
  //rpc_history[this_rpc_count]=form;
  global_rpc_counter++;
  var once=true;
  var wrapped_error_callback=function(r) {
    if(once) {
      once=false;
      error_callback(r);
    } // else just eat it. don't bother the client multiple times
  }
  rpc(url,form,function (response) {
    if(response.readyState == 4) {
      if (response.status == 204) {
        wrapped_error_callback(response);
        ; // useless 204
      } else if(response.status == 200) {
        if(response.responseXML) {
          if(response.responseXML.documentElement && response.responseXML.documentElement.tagName == "parsererror") {
	    bogo_response=response;
            wrapped_error_callback(response);
          } else {
            if(callback) {
              callback(response.responseXML);
            }
          }
        } else {
          alert('200 error status -- perhaps XML is bogus?');
          wrapped_error_callback(response);
        }
      } else {
        wrapped_error_callback(response);
      }
    }
  },wrapped_error_callback);
}
