//
// Functions to mitigate cross-browser nuttiness
//

var portable = new Object;

// BrowserDetect is cribbed wholesale from quirksmode
//
portable.BrowserDetect = {
	init: function () {
		this.browser = this.searchString(this.dataBrowser) || "An unknown browser";
		this.version = this.searchVersion(navigator.userAgent)
			|| this.searchVersion(navigator.appVersion)
			|| "an unknown version";
		this.OS = this.searchString(this.dataOS) || "an unknown OS";
	},
	searchString: function (data) {
		for (var i=0;i<data.length;i++)	{
			var dataString = data[i].string;
			var dataProp = data[i].prop;
			this.versionSearchString = data[i].versionSearch || data[i].identity;
			if (dataString) {
				if (dataString.indexOf(data[i].subString) != -1)
					return data[i].identity;
			}
			else if (dataProp)
				return data[i].identity;
		}
	},
	searchVersion: function (dataString) {
		var index = dataString.indexOf(this.versionSearchString);
		if (index == -1) return;
		return parseFloat(dataString.substring(index+this.versionSearchString.length+1));
	},
	dataBrowser: [
		{ 	string: navigator.userAgent,
			subString: "OmniWeb",
			versionSearch: "OmniWeb/",
			identity: "OmniWeb"
		},
		{
			string: navigator.vendor,
			subString: "Apple",
			identity: "bogoSafari"
		},
		{
			prop: window.opera,
			identity: "Opera"
		},
		{
			string: navigator.vendor,
			subString: "iCab",
			identity: "iCab"
		},
		{
			string: navigator.vendor,
			subString: "KDE",
			identity: "Konqueror"
		},
		{
			string: navigator.userAgent,
			subString: "Firefox",
			identity: "Firefox"
		},
		{
			string: navigator.vendor,
			subString: "Camino",
			identity: "Camino"
		},
		{		// for newer Netscapes (6+)
			string: navigator.userAgent,
			subString: "Netscape",
			identity: "Netscape"
		},
		{
			string: navigator.userAgent,
			subString: "MSIE",
			identity: "Explorer",
			versionSearch: "MSIE"
		},
		{
			string: navigator.userAgent,
			subString: "Gecko",
			identity: "Mozilla",
			versionSearch: "rv"
		},
		{ 		// for older Netscapes (4-)
			string: navigator.userAgent,
			subString: "Mozilla",
			identity: "Netscape",
			versionSearch: "Mozilla"
		}
	],
	dataOS : [
		{
			string: navigator.platform,
			subString: "Win",
			identity: "Windows"
		},
		{
			string: navigator.platform,
			subString: "Mac",
			identity: "Mac"
		},
		{
			string: navigator.platform,
			subString: "Linux",
			identity: "Linux"
		}
	]

};
portable.BrowserDetect.init();

// turn a 'Ctrl-a' into "a"
portable.keypress_to_string = function(e) {
  var charcode;
  var str;
  // safari 2.0 on mac supports which and keyCode indifferently
  // firefox 2.0 on mac supports which
  // does anyone support only charCode? safari exports it.
  if(e.which) {
    charcode=e.which;
  } else {
    charcode=e.keyCode;
  }
  // Safari 2.0 on Mac lets us see the ctrl key, but generates
  // conventional ASCII control codes before we get a chance.
  // we can undo those here
  if(e.ctrlKey && charcode>=1 && charcode<=26) {
    str=String.fromCharCode(97+charcode-1);
  } else {
    str=String.fromCharCode(charcode);
  }
  return str;
}

portable.shim_selection = function(win,new_element) {
  var a = win.getSelection();
  var firstparent=false;
  if(a.rangeCount) {
    var ranges=new Array();
    var x;
    for(x=0;x<a.rangeCount;x++) {
      ranges[x]=a.getRangeAt(x);
      ranges[x].surroundContents(new_element);
      ranges[x].deleteContents();
    }
    ranges[0].insertNode(new_element);
  }
}

portable.spinoff_selection = function(win) {
  var a = win.getSelection();
  var dsub = document.createElement('div');
  if(a.rangeCount) {
    var ranges=new Array();
    var x;
    for(x=0;x<a.rangeCount;x++) {
      ranges[x]=a.getRangeAt(x);
      ranges[x].surroundContents(dsub);
      ranges[x].deleteContents();
    }
    { 
      var new_window=window.open('/jsshell/sub.xhtml','','');
      new_window.onload=function() {
        new_window.document.body.appendChild(dsub);
      }
    }
  }
}

portable.hide_selection = function (win) {
  var a = win.getSelection();
  var t = document.createElement('a');
  //var i = document.createElement('img');
  //i.src='/artwork/crumple.png';
  //i.width=64;
  var i = document.createElement('div');
  i.appendChild(document.createTextNode('--hidden selection--'));
  //t.appendChild(document.createTextNode('unpack'));
  t.appendChild(i);
  var d = document.createElement('div');
  var dsub = document.createElement('div');
  d.appendChild(t);
  t.onclick=function(e) {
    if(portable.meta_key_p(e)) {
      var new_window=window.open('/jsshell/sub.xhtml','','');
      new_window.onload=function() {
        new_window.document.body.appendChild(dsub);
        d.parentNode.removeChild(d);
      }     
    } else {
      d.removeChild(t);
      d.appendChild(dsub);
    }
  }
  if(a.rangeCount) {
    var ranges=new Array();
    var x;
    for(x=0;x<a.rangeCount;x++) {
      ranges[x]=a.getRangeAt(x);
      ranges[x].surroundContents(dsub);
      ranges[x].deleteContents();
    }
    win.document.body.appendChild(d);
  }
}

portable.add_to_selection = function(win) {
  // win.getSelection is a mozillaism
  var a = win.getSelection();

  if(a.deleteFromDocument) {
    if(a.isCollapsed) {
      var n;
      n=a.anchorNode;
      alert('suitable for insertion: ' + a.anchorNode);
    }
  }
}

portable.delete_selection = function(win) {
  // win.getSelection is a mozillaism
  var a = win.getSelection();

  if(a.deleteFromDocument) {
      if(a.isCollapsed) {
        // this wasn't a selection, just a stray focus
      } else {
        a.deleteFromDocument();
      }
  } else if(a.rangeCount) {
    var i;
    var r;
    for(i=0;i<a.rangeCount;i++) {
      r = a.getRangeAt(i);
      //alert('whacking range ' + i + ' -- ' + r);
    }
  } else {
    if(a && a.anchorNode && a.anchorNode.nodeValue) {
      if(typeof(a.anchorNode.nodeValue) == 'string') {
        a.anchorNode.nodeValue='';
      }
    }
  }
}

portable.replace_selection = function(win,text) {
 var a = win.getSelection();
 if(a.rangeCount) {
   var r=a.getRangeAt(0);
   r.deleteContents();
   if(typeof(text) == "string") {
     r.insertNode(document.createTextNode(text)); 
   } else if(text) {
     r.insertNode(text); 
   }
 }
}

portable.target_to_string = function(target) {
  return target.nodeValue;
}

portable.selection_to_string = function(win) {
  var a = win.getSelection(); // yields an object -- use .toString to make a real string. escape() will url-escape it
  var retval;
  var retstring='';
  var x;
  var r;

  function trawl(node) {
    var count,child;
    for(count=0;count<node.childNodes.length;count++) {
      child=node.childNodes[count];
      if(child.nodeType == 3) {
        retstring+=child.data;
      } else if(child.nodeType == 1) {
        if(child.nodeName == "BR") {
          retstring+='\n';
        } else {
          trawl(child);
        }
      }
    }
  }

  // we accumulate the selection this way to 
  // preserve newlines and whitespaces.
  if(a && !a.isCollapsed && a.anchorNode) {
    for(x=0;x<a.rangeCount;x++) {
      r=a.getRangeAt(x);
      var subd=r.cloneContents();
      trawl(subd);
      //retstring+=r.toString()+'';
    }
    retval=retstring;
  } else {
    return false;
  }

  // Safari loves to dump char code 160 into string selections near some spaces.
  // These wind up in Guile as 302, 240
  // 160 is commonly used in HTML to mean a non-breaking space
  // In some browsers (inc Safari 2.0) regexps don't seem to catch nbsp
  {
    var ar;
    ar=retval.split("\u00A0");
    if(ar.length != 1) { 
      var concat,x,l
      l=ar.length
      concat=ar[0];
      for(x=1;x<ar.length;x++) {
        concat+=' '+ar[x]; 
      }
      retval=concat;
    }
  }
  return retval;
};

portable.selection_to_source = function (win) {
  var a = win.getSelection();
  var b = getSelection();
  alert('a: ' + typeof(a) + ' -- ' + a);
  alert('b: ' + typeof(b) + ' -- ' + b);

  return "bogo";
}

// a predicate on whether the local webapp shift key is pressed
portable.shift_key_p = function (e) {
  if(e.shiftKey) {
    return true;
  }
  return false;
}

// a predicate on whether the local webapp meta key is pressed.
portable.meta_key_p = function (e) {
  // We shouldn't consume meta or alt on the Mac
  // together with keypress without thinking about
  // it carefully. Meta is typically reserved for
  // the application, and
  // alt is typically involved with international
  // keystrokes.
  // Firefox 2.0 doesn't appear to allow some
  // option-<keystroke> international keycodes into
  // text elements. What a drag! You can still insert them
  // via the character palette
  if(portable.BrowserDetect.OS == 'Mac') {
    if(e.type == 'keypress') {
      // alt-keypress is probably international character
      // meta-keypress is probably application
      if(e.ctrlKey) {
        return true;
      }
    } else {
      // ctrl-click is probably right-mouse-button
      if(e.metaKey) { 
        return true;
      } else if(e.altKey) {
        return true;
      }
    }
  } else {
    if(e.metaKey || e.altKey || e.ctrlKey) {
      return true;
    }
  }
  return false;
}

// code from the old slider.js
 
  var global_zindex=0; 

portable.make_subwindow_with_element_and_dimensions = function(document,layer_name,element,fooclass,width,height) {
  var layer_val;
  var menubar_div;
  var resize_div;
  var content_div;
  var window_state=0;
  var resize_state=0;

  var startX=0;
  var startY=0;
  var baseX=0;
  var baseY=0;
  var layer_height;
  var layer_width;

  if(width) {
    layer_width=width;
  } else {
    layer_width=200;
  }
    
  if(height) {
    layer_height=height;
  } else {
    layer_height=200;
  }

  function window_adjust(x,y) {
    if( (baseX + x) < 0) {
      baseX = 0;
    } else {
      baseX += x;
    }
    if( (baseY + y) < 0) {
      baseY = 0;
    } else {
      baseY += y;
    }
    layer_val.style.left=baseX + 'px';
    layer_val.style.top=baseY + 'px';
  };

  function window_resize(x,y) {
    layer_width += x;
    layer_height += y;
    layer_val.style.width=layer_width + 'px';
    layer_val.style.height=layer_height + 'px';
  };

  if(typeof(layer_name) == 'string') {
    layer_val=document.getElementById(layer_name);
  } else {
    layer_val=layer_name;
  }
  if(fooclass) {
    layer_val.className=fooclass;
  }
  menubar_div=document.createElement('DIV');
  content_div=document.createElement('DIV');
  resize_div=document.createElement('DIV');

  menubar_div.addEventListener('mousedown',function(event) {
    window_state=1; startX=event.screenX; startY=event.screenY;
    event.stopPropagation();
  }, false);
  menubar_div.addEventListener('mousemove',function(event) {
    if(window_state == 1) {
      window_adjust(event.screenX-startX,event.screenY-startY); startX=event.screenX; startY=event.screenY;
    }
    event.stopPropagation();
  }, false);
  menubar_div.addEventListener('mouseup',function(event) {
    window_state=0; window_adjust(event.screenX-startX,event.screenY-startY);
    event.stopPropagation();
  }, false);

  resize_div.onmousedown=function (event) {resize_state=1; startX=event.screenX; startY=event.screenY;};
  resize_div.onmousemove=function (event) {if(resize_state == 1) { window_resize(event.screenX-startX,event.screenY-startY); startX=event.screenX; startY=event.screenY;} };
  resize_div.onmouseup=function (event) {resize_state=0; window_resize(event.screenX-startX,event.screenY-startY);};

  layer_val.style.position='absolute';
  layer_val.style.width=layer_width + 'px'
  layer_val.style.height=layer_height + 'px';
  menubar_div.style.height='3em';

  menubar_div.appendChild(document.createElement('hr'));
  menubar_div.appendChild(document.createTextNode('bogobogo'));
  menubar_div.appendChild(document.createElement('hr'));

  menubar_div.style.backgroundColor="red";
  resize_div.style.height='3em';
  resize_div.innerHTML="resize";
  resize_div.style.backgroundColor="red";
  
  {
    var raise_button;
    raise_button=document.createElement('INPUT');
    raise_button.type='button';
    raise_button.value='raise';
    raise_button.onclick=function () { layer_val.style.zIndex = global_zindex; global_zindex++; };
    var close_button;
    close_button=document.createElement('INPUT');
    close_button.type='button';
    close_button.value='close';
    close_button.onclick=function () { document.body.removeChild(layer_val); }
    resize_div.appendChild(raise_button);
    resize_div.appendChild(close_button);
  }

  content_div.appendChild(element);
    
  layer_val.appendChild(menubar_div);
  layer_val.appendChild(content_div);
  layer_val.appendChild(resize_div);
}

portable.make_subwindow_with_element = function (document,layer_name,element,fooclass) {
  return portable.make_subwindow_with_element_and_dimensions(document,layer_name,element,fooclass,false,false);
}

portable.make_subwindow=function (document,layer_name,url) {
  var iframe;
  iframe=document.createElement('IFRAME');
  iframe.src=url;
  portable.make_subwindow_with_element(document,layer_name,iframe);
}

//
// accept a keypress event and re-emit it towards the element new_target
//
portable.bounce_keypress = function(event,new_target) {
var eprime;
  if(window.KeyEvent) {
    //mozilla
    eprime=document.createEvent("KeyboardEvent");
    eprime.initKeyEvent(event.type,event.bubbles,
                        event.cancelable,event.view,
                        event.ctrlKey,event.altKey,
                        event.shiftKey,event.metaKey,
                        event.keyCode,event.charCode);
  } else {
    //safari
    eprime=document.createEvent("KeyboardEvent");
    eprime.initUIEvent('keypress',true,true,event.view,1);
    eprime.keyCode=event.keyCode;
    eprime.charCode=event.charCode;
    eprime.ctrlKey=event.ctrlKey;
    eprime.altKey=event.altKey;
    eprime.shiftKey=event.shiftKey;
    eprime.metaKey=event.metaKey;
  }
  new_target.dispatchEvent(eprime);
};

// send a click event
portable.send_click = function(target) {
var eprime;
  if(window.KeyEvent) {
    //mozilla
    eprime=document.createEvent("MouseEvent");
    eprime.initMouseEvent(
      'click', // type
      false,   // canBubble
      true,    // cancelable
      window,  // view
      false,   // detail
      false,   // screenX
      false,   // screenY
      false,   // clientX
      false,   // clientY
      false,   // ctrlKey
      false,   // altKey
      false,   // shiftKey
      false,   // metaKey
      1,       // button
      null    // relatedTarget
    );
  } else {
    //safari
    alert('unimplemented in Safari at present');
/*
    eprime=document.createEvent("KeyboardEvent");
    eprime.initUIEvent('keypress',true,true,event.view,1);
    eprime.keyCode=event.keyCode;
    eprime.charCode=event.charCode;
    eprime.ctrlKey=event.ctrlKey;
    eprime.altKey=event.altKey;
    eprime.shiftKey=event.shiftKey;
    eprime.metaKey=event.metaKey;
*/
  }
  target.dispatchEvent(eprime);
};

// copy the system clipboard into the input element
portable.paste=function(input_element) {
  // this is very mozilla-centric
  // and has the same outline as an example posted at
  // http://www.webdeveloper.com/forum
  // the original attribution of that code is unknown
  try {
    netscape.security.PrivilegeManager.enablePrivilege('UniversalXPConnect');
    var clipboard_id=Components.interfaces.nsIClipboard;
    var clipboard=Components.classes['@mozilla.org/widget/clipboard;1'].getService( clipboard_id );
    var transfer = Components.classes['@mozilla.org/widget/transferable;1'].createInstance( Components.interfaces.nsITransferable );
    transfer.addDataFlavor( 'text/unicode' );
    clipboard.getData( transfer, clipboard_id.kGlobalClipboard );
    var str = new Object();
    var strLength = new Object();
    transfer.getTransferData( 'text/unicode', str, strLength );
    str = str.value.QueryInterface( Components.interfaces.nsISupportsString );
    if((str+'').length > 0) {
      input_element.value=str;
    }
    return true;
  } catch(e) {
    alert('cannot paste yet');
    return false;
  }
};

// copy the current selection into the system clipboard
portable.copy=function() {
  // this is very mozilla-centric
  // and has the same outline as an example posted at
  // http://www.dynamic-tools.net
  // the original attribution of that code is unknown
  try {
    var copytext=window.getSelection()+'';
    netscape.security.PrivilegeManager.enablePrivilege('UniversalXPConnect');
    var clipboard_id=Components.interfaces.nsIClipboard;
    var clipboard=Components.classes['@mozilla.org/widget/clipboard;1'].getService( clipboard_id );
    var transfer = Components.classes['@mozilla.org/widget/transferable;1'].createInstance( Components.interfaces.nsITransferable );
    transfer.addDataFlavor( 'text/unicode' );
    var str=Components.classes['@mozilla.org/supports-string;1'].createInstance( Components.interfaces.nsISupportsString );
    str.data=copytext;
    transfer.setTransferData( 'text/unicode', str, copytext.length * 2);
    clipboard.setData(transfer,null,clipboard_id.kGlobalClipboard);
    return true;
  } catch(e) {
    alert('cannot copy yet');
    return false;
  }
};


// is the device touch enabled

var boot_is_ipad=function() {
    if(navigator && navigator.platform && navigator.platform == 'iPad') {
      return true;
    } else {
      return false;
    }
};

portable.isresizable=function() {
  if(boot_is_ipad()) {
    return false; 
  } else {
    return true;
  }
};

