function weather_widget(shell) {

    var url='http://www.weather.gov/xml/current_obs';

    // return a list of string selections
    var parse_selection=function() {
      var i;
      var r=[];
      var s=window.getSelection();
      for(i=0;i<s.rangeCount;i++) {
        r[r.length]=s.getRangeAt(i)+'';
      }
      return r;
    };

    var get_simple_text = function(node) {
      var acc='';
      var x;
      for(x=0;x<node.childNodes.length;x++) {
        acc+=node.childNodes[x].nodeValue;
      }
      return acc;
    };

    var get_xml = function(url,next) {

      var req=false;
      if(window.XMLHttpRequest) {
        req=new XMLHttpRequest();
      }

      if(req) {
        try {
          netscape.security.PrivilegeManager.enablePrivilege('UniversalBrowserRead');
        } catch(e) {
          alert('failure');
        }
        req.open('POST',url,true);
        req.onreadystatechange=function(e) {
          if(req.readyState == 4) {
            // FireFox 3+ do not seem to require this
            try {
              netscape.security.PrivilegeManager.enablePrivilege('UniversalBrowserRead');
            } catch(e) {
              alert('failure in orsc');
            }
            if(req.status == 200) {
              if(req.responseXML) {
                next(req.responseXML);
              } else {
                alert('boo hoo');
              }
            }
          } else {
            //alert('state: ' + req.readyState);
          }
        };
        req.onerror=function(e) {
          alert('error');
        };
        req.overrideMimeType('text/xml');
        req.send('');
      }
    };

    var report_to_temp = function(xml) {
      var collection=xml.getElementsByTagName('temp_f');
      var hit;
      hit=collection[0];
      return get_simple_text(hit);
    };

    var get_temp_for_station = function(station,next) {
      get_xml(url+'/'+station+'.xml',function(x) { 
        var t=report_to_temp(x);
        next(t);
      });
    };

    var station_hash=new Array;

    var get_stations=function() {
      var stations=0;
      get_xml('http://www.weather.gov/xml/current_obs/index.xml',function(x) { 
      
        var index=x.getElementsByTagName('wx_station_index');
        if(index) {
          index=index[0]; 
        }
        var x,hit;

        for(x=0;x<index.childNodes.length;x++) {
          if(index.childNodes[x].nodeName == 'station') {
            stations++;
            var i=index.childNodes[x].getElementsByTagName('station_id');
            if(i) {
              var sname=get_simple_text(i[0]);
              station_hash[sname]=true;
            } else {
              alert('done');
              break;
            }
          }
        }
      });
    };

    get_stations();

    shell.add_to_context_menu('temp lookup',function(e) {
      var i;
      var s=parse_selection();
      var ws=window.getSelection();
      var not_a_station;
      if(s.length == 1) {
        not_a_station=function(s) { alert('not a station: "' + s + '"'); };
      } else {
        not_a_station=function(s) { true; };
      }
      for(i=0;i<s.length;i++) {
        if(s[i].match(/^[A-Z][A-Z][A-Z][A-Z][0-9]*$/)) {
          if(station_hash[s[i]]) {
            (function(station,station_index) {
              get_temp_for_station(station,function(t) {
                if(ws && ws.rangeCount) {
                  var r=ws.getRangeAt(station_index);
                  var replacement_span=document.createElement('span');
                  var replacement_text=' (' + t + ') ' + station;
                  var replacement_anchor=document.createElement('a');
                  replacement_anchor.setAttribute('href',url+'/'+station+'.xml');
                  replacement_anchor.appendChild(document.createTextNode('go'));
                  replacement_span.style.borderStyle='dotted';
                  replacement_span.style.borderWidth='1px';

                  // this gets nervous unless we clear it first
                  r.deleteContents();
                  replacement_span.appendChild(document.createTextNode(replacement_text));
                  replacement_span.appendChild(replacement_anchor);
                  r.insertNode(replacement_span);
                } else {
                  alert(t);
                }
              });
            })(s[i],i);
          } else {
            not_a_station(s[i]);
          }
        } else {
          not_a_station(s[i]);
        }
      }
    });
}
