#!/bin/bash

#
# For use behind an Apache. Find proverb at
# nph-proxy.cgi/foo/jsshell/jsshell.html
#

#
# This script depends on a local installation of curl
#

if [ -z "${PATH_INFO}" ] ; then
  NPI="/"
else
  NPI=`echo "${PATH_INFO}" | sed 's/^\/foo//'`
fi

#
# This is obviously site-specific
#
#PROVERB_BASE=http://wafer.local:57964
PROVERB_BASE=http://127.0.0.1:11546

if [ -z "${USER}" ] ; then
  USER=cgi-user
fi

#SPOOL="${USER}-"`date '+%s'`"-${RANDOM}"
INTERIOR_URL="${PROVERB_BASE}/${NPI}"
if [ -n "${QUERY_STRING}" ] ; then
  INTERIOR_URL="${INTERIOR_URL}?${QUERY_STRING}"
fi

#mkdir -p /tmp/proxy.log/

#
# Curl will deliver a complete HTTP response to stdout
#
if [ "${REQUEST_METHOD}" = "POST" ] ; then
  if [ -z "${HTTP_ORIGIN}" ] ; then
    curl -D - --data-binary "@-" "${INTERIOR_URL}" 2> /dev/null
  else
    curl -D - -H "Origin: ${HTTP_ORIGIN}" --data-binary "@-" "${INTERIOR_URL}" 2> /dev/null
  fi
elif [ "${REQUEST_METHOD}" = "GET" ] ; then
  curl -D - "${INTERIOR_URL}" 2> /dev/null
fi

