#!/usr/local/bin/python
#
#   l i s p i o . p y
#
#   Copyright 2001 by Chris Meyers. 
#   Additions copyright 2008 by Daniel Ridge
#
import string, sys

inputter = None
inlin = ""

def putSexp (s):
    "return string form of an S expression"
    if type(s) == type([]) :
        if 0 and len(s) and s[0] == 'quote' : return "'" + putSexp(s[1:])
        else : return '(' + string.join(map(putSexp,s)) + ')'
    else : return str(s)

def getSexp (source) :       # get an S expression from the user
    "return and discard the next S expression, along with any nested ones in input"
    a = getToken(source)
    if   a == "'" : return ['quote', getSexp()]
    elif a != '(' : return a
    a = []
    while 1 :
        b = getSexp(source)
        if b == ')' : return a
        a.append(b)

def getInt (source) :
    "return and discard the next integer immediately in input"
    acc = []
    a = getChar(source)
    while a in ['0','1','2','3','4','5','6','7','8','9']:
      acc.append(a)
      a = getChar(source)

    return (int("".join(acc)),a)

def getSchemeString (source) :
    acc = []
    alive = True
    while alive:
      a = getChar(source)
      if a == '\\':
        b = getChar(source)
        if b == 'n':
          acc.append('\n')
        else:
          acc.append(b)
      elif a == '"':
        alive=False
      else:
        acc.append(a)
    return "".join(acc)

def getToken (source) :
    "return and discard the next symbol, number or special character in input"
    while nextChar(source) <= ' ': getChar(source)  # skip whitespace
    a = getChar(source)
    if a in ['(',')',"'"] : return a
    elif a == '"':
      return getSchemeString(source)
    elif a == '#' :
      b = getChar(source)
      if b == "t" :
        return True
      elif b == "f" :
        return False
      elif b == "b":
        c = getChar(source)
        if c == "#":
          (str_len,str_start) = getInt(source)
          if str_start == "#":
            if str_len == 0 : 
              return ""
            else:
              return source.read(str_len)
          else:
            print "YOU HAVE AN INVALID HASH B"
        else:
          print "YOU HAVE AN INVALID HASH B"
          raise "TIRE ERROR"
    while nextChar(source) > ' ' and nextChar(source) not in ['(',')'] :
        a = a + getChar(source)
    try    : return float(a)   # if a number, make it a float
    except : return a          # otherwise a string with the symbol name
        
def nextCharOld() :
    """return (but don't discard) the next character in the input stream
       get more from the user if needed"""
    global inlin
    if inlin == "" : inlin = raw_input("Lisp>") + '\n'
    return inlin[0:1]
    
def nextChar(source) :
    """return (but don't discard) the next character in the input stream
       get more from the user if needed"""
    global inlin
    if inlin == "" : 
        inlin = source.read(1)
        if inlin == "" : raise "EOF error"
    return inlin[0:1]
    
def getChar(source) :
    """return and discard the next character in the input stream"""
    global inlin
    c = nextChar(source)
    inlin = inlin[1:]
    return c
    

