#!/usr/bin/env python

#
# Python bindings for Proverb
#

import string, sys, subprocess, lispio

# If no arguments were given, print a helpful message
if len(sys.argv) == 1:
    print 'Usage: pyverb subordinate-proverb-cmdline'
    sys.exit(0)

child=subprocess.Popen(sys.argv[1:], stdout=subprocess.PIPE, stdin=subprocess.PIPE)
(child_stdin, child_stdout) = (child.stdin, child.stdout);

def nextChar() :
    """return and discard the next character in the input stream"""
    return child_stdout.read(1)

def do_tire_rpc(io,type,tag,cookie,command,rest):
  (write,read) = io
  print "Writing..."
  write.writelines(["(" + type + " " + tag + " " + cookie + " " + command + " " + rest + ")\n"])
  write.flush()
  print "Reading"
  def bogon():
    response = lispio.getSexp(read)
    if response[0] != "r":
      return bogon()
    elif response[1] != tag:
      return bogon()
    else:
      return response
  return bogon()

global_tag_counter = 0

def do_tire_remote_eval(io,cookie,form):
  global global_tag_counter
  response = do_tire_rpc(io,"t","pytag-" + str(global_tag_counter),cookie,"eval",form)
  global_tag_counter = global_tag_counter + 1
  return response[2]

res = do_tire_rpc((child_stdin, child_stdout),"t","-","local","eval","(getpid)")
print res

res = do_tire_rpc((child_stdin, child_stdout),"t","-","local","eval","(fork-add)")
print res

res = do_tire_remote_eval((child_stdin, child_stdout),"local","(getpid)")
print res

res = do_tire_remote_eval((child_stdin, child_stdout),"local","(getpid)")
print res

print "Still here."

sys.exit(0);
