<?xml version="1.0"?>
<xsl:stylesheet xmlns:foo="http://www.w3.org/2000/sexp" version="1.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:verb="bogobogo"
>
  <xsl:output method="text"/>

  <xsl:template name="atom">
    <xsl:if test="name()='number'">
      <xsl:call-template name="number"/>
    </xsl:if>
    <xsl:if test="name()='symbol'">
      <xsl:call-template name="symbol"/>
    </xsl:if>
    <xsl:if test="name()='boolean'">
      <xsl:call-template name="boolean"/>
    </xsl:if>
    <xsl:if test="name()='string'">
      <xsl:call-template name="string"/>
    </xsl:if>
    <xsl:if test="name()='vector'">
      <xsl:call-template name="vector"/>
    </xsl:if>
    <xsl:if test="name()='list'">
      <xsl:call-template name="list"/>
    </xsl:if>
    <xsl:if test="name()='pair'">
      <xsl:call-template name="pair"/>
    </xsl:if>
    <xsl:if test="name()='unspecified'">
      <xsl:call-template name="unspecified"/> 
    </xsl:if>
    <xsl:if test="name()='port'">
      <xsl:call-template name="port"/>
    </xsl:if>
  </xsl:template> 

  <xsl:template name="list">
    <xsl:text>(</xsl:text>
    <xsl:for-each select="*">
      <xsl:call-template name="atom"/><xsl:text> </xsl:text>
    </xsl:for-each>
    <xsl:text>)</xsl:text>
  </xsl:template> 

  <xsl:template name="pair">
    <xsl:text>(</xsl:text>
    <xsl:for-each select="*[position()=1]">
      <xsl:call-template name="atom"/>
    </xsl:for-each>
    <xsl:text> . </xsl:text>
    <xsl:for-each select="*[position()=2]">
      <xsl:call-template name="atom"/>
    </xsl:for-each>
    <xsl:text>)</xsl:text>
  </xsl:template>

  <xsl:template name="vector">
    <xsl:text>#(</xsl:text>
    <xsl:for-each select="*">
      <xsl:call-template name="atom"/>
    </xsl:for-each>
    <xsl:text>)</xsl:text>
  </xsl:template>

  <xsl:template name="string">"<xsl:value-of select="text()"/>"</xsl:template>

  <xsl:template name="symbol"><xsl:value-of select="@name"/></xsl:template>

  <xsl:template name="boolean"><xsl:if test="@value='true'">#t</xsl:if><xsl:if test="@value='false'">#f</xsl:if></xsl:template>
 
  <xsl:template name="number"><xsl:value-of select="@value"/></xsl:template>

  <xsl:template name="unspecified">*unspecified*</xsl:template>

  <xsl:template name="port"><xsl:value-of select="text()"/></xsl:template>

  <xsl:template match="/foo:sexp">
    <xsl:for-each select="/foo:sexp/*">
      <xsl:call-template name="atom"/>
    </xsl:for-each>
    <xsl:value-of select="text()"/>
  </xsl:template>
</xsl:stylesheet>
